var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxForms = MsPortalFx.ViewModels.Forms;
    var ContactInfoBladeViewModel = (function (_super) {
        __extends(ContactInfoBladeViewModel, _super);
        function ContactInfoBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this.subscriptionId = ko.observable();
            _this.location = ko.observable();
            _this.title = ko.observable("Contact Info");
            _this.icon = ko.observable(MsPortalFx.Base.Images.Person());
            _this._container = container;
            _this._dataContext = dataContext;
            _this._initializeFormFields(container, initialState);
            _this._setupCommandBar();
            return _this;
        }
        ContactInfoBladeViewModel.prototype._initializeFormFields = function (container, initialState) {
            var firstNameOptions = {
                label: ko.observable("First Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\-]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("First Name"),
                readonly: true
            };
            var firstNameTxField = new FxForms.TextBox.ViewModel(container, firstNameOptions);
            firstNameTxField.value("Jagan");
            var lastNameOptions = {
                label: ko.observable("Last Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\-]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Last Name"),
                readonly: true
            };
            var lastNameTxField = new FxForms.TextBox.ViewModel(container, lastNameOptions);
            lastNameTxField.value("Kris");
            var emailOptions = {
                label: ko.observable("Contact Email"),
                validations: ko.observableArray([]),
                emptyValueText: ko.observable("Contact Email"),
                readonly: true
            };
            var emailTxField = new FxForms.TextBox.ViewModel(container, emailOptions);
            emailTxField.value("jagan@cloudassert.com");
            var phoneOptions = {
                label: ko.observable("Phone Number"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[0-9\+]+[0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Phone Number"),
                readonly: true
            };
            var phoneNumberTxField = new FxForms.TextBox.ViewModel(container, phoneOptions);
            phoneNumberTxField.value("425 628 9105");
            var companyOptions = {
                label: ko.observable("Company"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[A-Za-z0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Company"),
                readonly: true
            };
            var companyTxField = new FxForms.TextBox.ViewModel(container, companyOptions);
            companyTxField.value("Cloud Assert LLC");
            var sectionOptions = {
                children: ko.observableArray([
                    firstNameTxField,
                    lastNameTxField,
                    emailTxField,
                    phoneNumberTxField,
                    companyTxField
                ])
            };
            this.generalSection = new FxForms.Section.ViewModel(container, sectionOptions);
        };
        ContactInfoBladeViewModel.prototype._setupCommandBar = function () {
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([]);
        };
        ContactInfoBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var args = {};
            return Q();
        };
        return ContactInfoBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.ContactInfoBladeViewModel = ContactInfoBladeViewModel;
});
