var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var CostBreakdownDonutPartViewModel = (function (_super) {
        __extends(CostBreakdownDonutPartViewModel, _super);
        function CostBreakdownDonutPartViewModel(container, initialState, dataContext) {
            var _this = _super.call(this, container) || this;
            _this.subscriptionId = ko.observable();
            _this.billingPeriod = ko.observable();
            _this._data = ko.observableArray([]);
            container.partTitle("Costs by metered resource");
            _this._container = container;
            _this._dataContext = dataContext;
            var itemSettings = {
                valueKey: "amount",
                labelKey: "label",
                selectedKey: "selected",
                hoveredIndex: ko.observable(),
            };
            _this.itemSetting(itemSettings);
            _this.total(0);
            _this.unitFormat("USD");
            _this.infoFormat("Itemized Bill");
            _this.hoveredUnit("USD");
            _this.showLegend();
            var projectedItems = _this._data.map(container, function (itemLifetime, lineItem) {
                return {
                    label: lineItem.MeteredResourceDisplayName,
                    amount: lineItem.BillableCost,
                    selected: ko.observable(false),
                };
            });
            projectedItems.subscribe(container, _this.itemsDataArray);
            ko.reactor(container, function () {
                var total = 0;
                projectedItems().forEach(function (value) {
                    total += value.amount;
                });
                _this.total(total);
                _this.render();
            });
            return _this;
        }
        CostBreakdownDonutPartViewModel.prototype.onInputsSet = function (inputs) {
            var _this = this;
            this.subscriptionId(inputs.subscriptionId);
            this.billingPeriod(inputs.billingPeriod);
            var subIds = this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
            if (inputs.isInvoice !== 'true') {
                var bp_1 = this.billingPeriod();
                var q = this._dataContext.sharedContext.billingOverviewManager.getBillingPeriods(subIds).then(function (billingPeriods) {
                    if (!bp_1) {
                        bp_1 = billingPeriods.first(function (x) { return x.IsCurrent; });
                    }
                    return _this._dataContext.sharedContext.billingOverviewManager.getConsumptionForBillingPeriod(_this.subscriptionId(), subIds, bp_1.Month, bp_1.Year);
                });
                q = q.then(function (usageRecords) {
                    _this.unitFormat(usageRecords.first().ISOCurrencySymbol);
                    _this.hoveredUnit(usageRecords.first().ISOCurrencySymbol);
                    _this._data(usageRecords);
                });
                return q;
            }
            return Q();
        };
        return CostBreakdownDonutPartViewModel;
    }(MsPortalFx.ViewModels.Parts.Donut.ViewModel));
    exports.CostBreakdownDonutPartViewModel = CostBreakdownDonutPartViewModel;
});
