var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ArmHelpers = Common.Helpers;
    var InvoiceDetailBladeViewModel = (function (_super) {
        __extends(InvoiceDetailBladeViewModel, _super);
        function InvoiceDetailBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this.subscriptionId = ko.observable();
            _this.invoiceId = ko.observable();
            _this.location = ko.observable("local");
            _this.invoiceData = ko.observable();
            _this.invoices = ko.observable();
            _this.title("Invoice");
            _this._container = container;
            _this._dataContext = dataContext;
            ko.reactor(container, function () {
                if (_this.invoices()) {
                    var x = _this.invoices();
                    _this.invoiceData(x);
                    _this.title("Invoice ({0})".format(x.BillingPeriodString));
                    _this.subtitle(x.SubscriptionId.toString());
                }
            });
            _this._setupCommandBar();
            return _this;
        }
        InvoiceDetailBladeViewModel.prototype._setupCommandBar = function () {
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([]);
        };
        InvoiceDetailBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.subscriptionId(inputs.subscriptionId);
            this.invoiceId(inputs.invoiceId);
            var subscriptionIds = this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
            var q = this._dataContext.sharedContext.invoicesManager.getInvoicesForSubscription(inputs.subscriptionId, subscriptionIds, inputs.invoiceId)
                .then(function (result) {
                _this.invoices(result);
            });
            return q;
        };
        InvoiceDetailBladeViewModel.prototype._getBillingPeriod = function (invoice) {
            var st = new Date(invoice.InvoiceStartTime());
            var et = new Date(invoice.InvoiceEndTime());
            var startTimeString = this._getUtcDateString(st);
            var endTimeString = this._getUtcDateString(et);
            var period = "{0}-{1}".format(startTimeString, endTimeString);
            return period;
        };
        InvoiceDetailBladeViewModel.prototype._getUtcDate = function (date) {
            var dateUtc = new Date(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate(), date.getUTCHours(), date.getUTCMinutes(), date.getUTCSeconds());
            return dateUtc;
        };
        InvoiceDetailBladeViewModel.prototype._getUtcDateString = function (date) {
            return "{0}/{1}/{2}".format(date.getUTCMonth() + 1, date.getUTCDate(), date.getUTCFullYear());
        };
        return InvoiceDetailBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.InvoiceDetailBladeViewModel = InvoiceDetailBladeViewModel;
});
