var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "../../Shared/Helpers"], function (require, exports, Helpers) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var FxDropDown = MsPortalFx.ViewModels.Obsolete.Forms.DropDown;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var FileDownload = MsPortalFx.ViewModels.Controls.FileDownload;
    var FileDownloadButton = MsPortalFx.ViewModels.Controls.FileDownloadButton;
    var Toolbars = MsPortalFx.ViewModels.Toolbars;
    var Images = MsPortalFx.Base.Images;
    var ArmHelpers = Common.Helpers;
    var InvoicesCollectionBladeViewModel = (function (_super) {
        __extends(InvoicesCollectionBladeViewModel, _super);
        function InvoicesCollectionBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this.isShowGrid = ko.observable(true);
            _this.subscriptionId = ko.observable();
            _this.location = ko.observable("local");
            _this.selectedInvoices = ko.observableArray([]);
            _this.invoicesList = ko.observableArray([]);
            _this._shouldShowPayInvoiceButton = ko.observable();
            _this.isStripeFeatureAvailable = ko.observable();
            _this._stripePaymentStatus = ko.observable();
            _this._stripePublicKey = ko.observable();
            _this._billingTenantUrl = ko.observable();
            _this.selectedInvoiceId = ko.observable();
            _this.selectedInvoice = ko.pureComputed(function () {
                var q = _this.invoicesGrid.selectableData.selectedItems().first();
                if (q != null) {
                    _this._shouldShowPayInvoiceButton(_this.isStripeFeatureAvailable() && (q.PaymentStatus() != 30));
                    if (_this._shouldShowPayInvoiceButton()) {
                        _this.commandBar.setItems([_this._payInvoiceButton, _this._refreshButton]);
                    }
                    else {
                        _this.commandBar.setItems([_this._refreshButton]);
                    }
                }
                return q;
            });
            _this.title("Invoices");
            _this._container = container;
            _this._dataContext = dataContext;
            _this.gridOrChartOptionPicker = new MsPortalFx.ViewModels.Forms.OptionsGroup.ViewModel(container, {
                options: ko.observableArray([
                    { text: ko.observable("Grid"), value: "Grid" },
                    { text: ko.observable("Chart"), value: "Chart" },
                ]),
                defaultValue: ko.observable("Grid")
            });
            var subscriptionDropDownOptions = {
                label: ko.observable("Subscription Name"),
                infoBalloonContent: ko.observable("Choose the Subscription for listing Invoices"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            _this.subscriptionsDropDown = new FxDropDown.ViewModel(container, subscriptionDropDownOptions);
            _this.subscriptionsDropDown.value.subscribe(container, function (newSubscriptionId) {
                _this.subscriptionId(newSubscriptionId);
            });
            _this._enabledFeaturesEntityView = _this._dataContext.sharedContext.licenseManager.enabledFeaturesEntity.createView(container, {
                interceptNotFound: false
            });
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1,
                    activateOnSelected: ko.observable(false)
                }
            };
            _this.invoicesGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    itemKey: "BillingPeriodString",
                    name: ko.observable("Billing Period"),
                    width: ko.observable("145px")
                },
                {
                    itemKey: "Id",
                    name: ko.observable("Invoice Id"),
                    width: ko.observable("70px")
                },
                {
                    itemKey: "UserId",
                    name: ko.observable("User"),
                    width: ko.observable("160px"),
                    activatable: ko.observable(true),
                    format: FxGrid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: Helpers.getGridNameActivatableTemplate(),
                        htmlBindingsType: FxGrid.HtmlBindingsType.Default
                    }
                },
                {
                    itemKey: "PaymentStatusString",
                    name: ko.observable("Payment Status"),
                    width: ko.observable("120px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.SvgIconLookup,
                    formatOptions: {
                        svgIconLookup: {
                            "Unpaid": {
                                svg: Images.StatusBadge.Info(),
                                text: ko.observable("Unpaid"),
                            },
                            "InProgress": {
                                svg: Images.StatusBadge.Pending(),
                                text: ko.observable("InProgress"),
                            },
                            "Failed": {
                                svg: Images.StatusBadge.Error(),
                                text: ko.observable("Failed"),
                            },
                            "Paid": {
                                svg: Images.StatusBadge.Success(),
                                text: ko.observable("Paid"),
                            }
                        }
                    }
                },
                {
                    itemKey: "FinalBillableAmountString",
                    name: ko.observable("Amount"),
                    width: ko.observable("70px"),
                    cssClass: "ext-ca-billing-grid-col-align-right",
                },
                {
                    itemKey: "DownloadInvoiceButton",
                    format: FxGrid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div data-bind='pcControl: value'></div>",
                        htmlBindingsType: FxGrid.HtmlBindingsType.Default
                    },
                    width: ko.observable("150px")
                },
            ];
            _this.invoicesGrid.columns = ko.observableArray(basicColumns);
            _this.invoicesGrid.showHeader = true;
            _this.invoicesGrid.summary = ko.observable("Summary");
            _this.invoicesGrid.noRowsMessage("No items found");
            _this.invoicesGrid.selectableData.selectedItems.subscribe(container, function (selectedItems) {
                if (!selectedItems || selectedItems.length === 0) {
                    _this.selectedInvoices([]);
                    return;
                }
                _this.selectedInvoices(selectedItems);
            });
            _this.invoicesList.subscribe(container, function (invoices) {
                var transformedItems = invoices.map(function (item) {
                    var invoice = Helpers.makeObservable(item);
                    var args = {
                        subscriptionId: invoice().SubscriptionId(),
                        invoiceId: invoice().Id(),
                    };
                    var downloadUri = _this._dataContext.sharedContext.invoicesManager.downloadInvoiceUriFormat(args);
                    var payUri = _this._dataContext.sharedContext.invoicesManager.payInvoiceUriFormat(args);
                    var invoiceFileDownloadContext = new FileDownload.Context({
                        targetUri: ko.observable(downloadUri),
                        httpMethod: ko.observable("GET"),
                        downloadType: ko.observable(2),
                        addDefaultAuthorizationToken: true,
                        showDownloadProgressDialog: ko.observable(true)
                    });
                    var invoiceDownloadLink = new FileDownloadButton.ViewModel(container, {
                        context: ko.observable(invoiceFileDownloadContext),
                        label: ko.observable("Download Invoice"),
                        disabled: ko.observable(false),
                        asLink: true
                    });
                    if (!invoice().CanTenantDownload()) {
                        invoiceDownloadLink.disabled = ko.observable(true);
                    }
                    return $.extend({}, invoice(), {
                        DownloadInvoiceButton: invoiceDownloadLink,
                        PayInvoiceUri: { uri: payUri, text: 'Pay Invoice', target: null }
                    });
                });
                _this.invoicesGrid.items(transformedItems);
            });
            _this.subscriptionId.subscribe(_this._container, function (subscriptionId) {
                if (!subscriptionId || subscriptionId === "-") {
                    _this.invoicesGrid.items([]);
                    return;
                }
                _this.invoicesGrid.loading(true);
                var subscriptionIds = _this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
                var q = _this._dataContext.sharedContext.invoicesManager.getInvoicesForSubscriptions(subscriptionId, subscriptionIds)
                    .then(function (invoices) {
                    _this.invoicesList(invoices);
                    _this.invoicesGrid.loading(false);
                });
                _this.commandBar.dispose();
                _this.commandBar.setItems([_this._refreshButton]);
                return q;
            });
            _this.gridOrChartOptionPicker.value.subscribe(_this._container, function (newValue) {
                _this.isShowGrid(newValue === 'Grid');
            });
            _this._setupCommandBar();
            _this._initBarChart(container);
            return _this;
        }
        InvoicesCollectionBladeViewModel.prototype._setupCommandBar = function () {
            this._refreshButton = this._createRefreshButton();
            this.commandBar = new Toolbars.Toolbar(this._container);
            this.commandBar.setItems([this._refreshButton]);
        };
        InvoicesCollectionBladeViewModel.prototype._openLinkButton = function () {
            var _this = this;
            var button = new Toolbars.OpenLinkButton({
                label: "Pay Invoice",
                icon: MsPortalFx.Base.Images.Hyperlink(),
                uri: this._billingTenantUrl() + "/Client/Billing/Templates/StripeCardDetails.html",
            });
            button.clickableLink.onLinkOpened = function (keypress) {
                localStorage["StripePublicKey"] = _this._stripePublicKey();
                _this.selectedInvoiceId(_this.selectedInvoice().Id());
                var q = _this._dataContext.sharedContext.invoicesManager.markInvoiceStatusAsInProgress(_this.subscriptionId(), _this.selectedInvoice().Id())
                    .then(function () {
                    _this._getInvoices().then(function () {
                        _this._payInvoiceViaStripe();
                        _this.commandBar.dispose();
                        _this.commandBar.setItems([_this._refreshButton]);
                    });
                });
                return q;
            };
            return button;
        };
        InvoicesCollectionBladeViewModel.prototype._payInvoiceViaStripe = function () {
            var self = this;
            var timer = setInterval(function () {
                if (localStorage["StripeToken"] && localStorage["StripeToken"].length > 0) {
                    clearInterval(timer);
                    var token = JSON.parse(localStorage["StripeToken"]);
                    var paymentDetails = {
                        StripeTokenIn: token,
                        InvoiceId: self.selectedInvoiceId()
                    };
                    self._dataContext.sharedContext.invoicesManager.payInvoiceViaStripe(self.subscriptionId(), paymentDetails)
                        .then(function (result) {
                        self._stripePaymentStatus(result);
                    })
                        .finally(function () {
                        localStorage["StripeToken"] = "";
                        localStorage["StripePublicKey"] = "";
                    });
                }
                else if (localStorage["IsStripeTokenError"]) {
                    clearInterval(timer);
                    var notification = new MsPortalFx.Hubs.Notifications.ClientNotification({
                        title: "Failure Stripe Token generation.Please Try again...",
                        description: localStorage["StripeTokenErrorMessage"],
                        status: MsPortalFx.Hubs.Notifications.NotificationStatus.Error
                    });
                    notification.publish();
                    localStorage["IsStripeTokenError"] = false;
                    localStorage["StripeTokenErrorMessage"] = "";
                    localStorage["StripePublicKey"] = "";
                }
            }, 5000);
        };
        InvoicesCollectionBladeViewModel.prototype._createRefreshButton = function () {
            var _this = this;
            var refreshButton = new FxToolbars.CommandButton({
                label: "Refresh",
                icon: MsPortalFx.Base.Images.Refresh(),
                command: {
                    canExecute: ko.observable(true),
                    execute: function (result) {
                        return _this._getInvoices();
                    }
                }
            });
            return refreshButton;
        };
        InvoicesCollectionBladeViewModel.prototype._getInvoices = function () {
            var _this = this;
            this.invoicesGrid.loading(true);
            var subscriptionIds = this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
            var q = this._dataContext.sharedContext.invoicesManager.getInvoicesForSubscriptions(this.subscriptionId(), subscriptionIds)
                .then(function (invoices) {
                _this.invoicesList(invoices);
                _this.invoicesGrid.loading(false);
            });
            return q;
        };
        InvoicesCollectionBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            return this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                var dropdownValues = subscriptions.map(function (s) {
                    return {
                        text: ko.observable(s.uniqueDisplayName),
                        value: s.subscriptionId,
                        disabled: ko.observable(false)
                    };
                });
                dropdownValues.unshift({
                    text: ko.observable("Select a subscription..."),
                    value: "-",
                    disabled: ko.observable(false)
                });
                _this.subscriptionsDropDown.options(dropdownValues);
                var subscriptionId = "-";
                if (subscriptions.length > 0)
                    subscriptionId = subscriptions.first().subscriptionId;
                _this.subscriptionsDropDown.value(subscriptionId);
                _this.subscriptionsDropDown.disabled(false);
                var args = {
                    subscriptionId: _this.subscriptionId(),
                    location: _this.location(),
                };
                _this._enabledFeaturesEntityView.fetch(args).then(function () {
                    var dataEntity = _this._enabledFeaturesEntityView.item();
                    if (dataEntity.Settings()["AllowTenantsToPayViaStripe"])
                        _this.isStripeFeatureAvailable(dataEntity.Settings()["AllowTenantsToPayViaStripe"]().toLowerCase() == 'true' ? true : false);
                    else
                        _this.isStripeFeatureAvailable(false);
                });
                _this._dataContext.sharedContext.invoicesManager.getStripePublishableAPIKey(_this.subscriptionId())
                    .then(function (apiKey) {
                    _this._stripePublicKey(apiKey);
                });
                _this._dataContext.sharedContext.invoicesManager.getBillingTenantExtUrl(_this.subscriptionId())
                    .then(function (tenantUrl) {
                    _this._billingTenantUrl(tenantUrl);
                    _this._payInvoiceButton = _this._openLinkButton();
                });
            });
        };
        InvoicesCollectionBladeViewModel.prototype._initBarChart = function (container) {
            var _this = this;
            this.barChartVM = new MsPortalFx.ViewModels.Controls.Visualization.Chart.ViewModel(container);
            var view = new MsPortalFx.ViewModels.Controls.Visualization.Chart.BarChartView(1);
            this.barChartVM.views([view]);
            this.barChartVM.xAxis.rotateLabel(-45);
            this.barChartVM.xAxis.labelPadding(200);
            this.barChartVM.yAxis.showGridLines(true);
            this.barChartVM.legendPosition(2);
            var invoiceAmountSeries = new MsPortalFx.ViewModels.Controls.Visualization.Chart.Series();
            invoiceAmountSeries.name("Amount");
            this.invoicesList.mapInto(container, function (itemLifetime, invoice) {
                var st = new Date(invoice.InvoiceStartTime());
                var startTimeString = _this._getUtcDateString(st);
                return {
                    xValue: startTimeString,
                    yValue: invoice.FinalBillableAmount()
                };
            }, invoiceAmountSeries.values);
            this.barChartVM.series([invoiceAmountSeries]);
        };
        InvoicesCollectionBladeViewModel.prototype._getBillingPeriod = function (invoice) {
            var st = new Date(invoice.InvoiceStartTime());
            var et = new Date(invoice.InvoiceEndTime());
            var startTimeString = this._getUtcDateString(st);
            var endTimeString = this._getUtcDateString(et);
            var period = "{0}-{1}".format(startTimeString, endTimeString);
            return period;
        };
        InvoicesCollectionBladeViewModel.prototype._getUtcDate = function (date) {
            var dateUtc = new Date(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate(), date.getUTCHours(), date.getUTCMinutes(), date.getUTCSeconds());
            return dateUtc;
        };
        InvoicesCollectionBladeViewModel.prototype._getUtcDateString = function (date) {
            return "{0}/{1}/{2}".format(date.getUTCMonth() + 1, date.getUTCDate(), date.getUTCFullYear());
        };
        return InvoicesCollectionBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.InvoicesCollectionBladeViewModel = InvoicesCollectionBladeViewModel;
});
