var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "../../Models/NotificationsModel"], function (require, exports, NotificationsModel) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var Dialogs = MsPortalFx.ViewModels.Dialogs;
    var Images = MsPortalFx.Base.Images;
    var FxForms = MsPortalFx.ViewModels.Forms;
    var NotificationAddEditBladeViewModel = (function (_super) {
        __extends(NotificationAddEditBladeViewModel, _super);
        function NotificationAddEditBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this._selectedEvent = ko.observable();
            _this.location = ko.observable("local");
            _this.isAdd = ko.observable(true);
            _this.isDisableCreditFields = ko.observable(true);
            _this.selectedSubscriptionId = ko.observable("");
            _this.firstSubscriptionId = ko.observable("");
            _this._subscriptionAndOfferDetails = ko.observable();
            _this.selectedRule = ko.observable();
            _this.icon(Images.Customize());
            _this._container = container;
            _this._dataContext = dataContext;
            _this._initializeFormFields(container);
            _this.eventsDdownField.value.subscribe(container, function (selectedEvent) {
                if (selectedEvent != null) {
                    _this._selectedEvent(selectedEvent);
                }
            });
            _this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(container);
            _this._setupCommandBar();
            return _this;
        }
        NotificationAddEditBladeViewModel.prototype._setupCommandBar = function () {
            this._saveButton = this._createSaveButton();
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([
                this._saveButton,
            ]);
        };
        NotificationAddEditBladeViewModel.prototype._createSaveButton = function () {
            var _this = this;
            var saveButton = new FxToolbars.DialogButton({
                label: "Save",
                icon: MsPortalFx.Base.Images.Commit(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure you want to save ?", 4),
            });
            saveButton.command = {
                canExecute: ko.observable(true),
                execute: function (context) {
                    if (context === 6) {
                        return _this._container.form.triggerValidation().then(function (validationPassed) {
                            if (validationPassed) {
                                return _this._onSaveChanges();
                            }
                            return null;
                        });
                    }
                },
            };
            return saveButton;
        };
        NotificationAddEditBladeViewModel.prototype._onSaveChanges = function () {
            var _this = this;
            var notificationRuleIn = {
                SubscriptionId: this.selectedSubscriptionId,
                Id: this.selectedRule().Id.toString(),
                DisplayName: this.displayNameTxField.value,
                RuleProviderId: this._selectedEvent(),
                NotificationEmails: this.emailIdsTxField.value,
                IsEnabled: this.isRuleEnabledOptionField.value,
                RuleParams: this._getRuleParams(),
            };
            var dataManager = this._dataContext.sharedContext.notificationsDataManager;
            var op;
            if (this.isAdd()) {
                notificationRuleIn.Id = '0';
                op = dataManager.addNotificationRuleQuery(this.selectedSubscriptionId(), this.location(), notificationRuleIn);
            }
            else {
                dataManager.updateNotificationRuleQuery(this.selectedSubscriptionId(), this.location(), notificationRuleIn);
            }
            this._container.operations.add(op, { blockUi: true });
            return op.then(function () {
                return {
                    action: MsPortalFx.Data.AcceptEditScopeChangesAction.AcceptClientChanges
                };
            }).finally(function () {
                _this._container.closeCurrentBlade();
            });
        };
        NotificationAddEditBladeViewModel.prototype._getRuleParams = function () {
            var ruleParams = {};
            var usageExceedValue = this.usageExceedTxField.value();
            if (usageExceedValue) {
                ruleParams['Value'] = usageExceedValue;
                ruleParams['Resource'] = 'TotalCost';
            }
            if (!this.isDisableCreditFields() || this.eventsDdownField.value() === "LowCreditValue") {
                ruleParams = {};
                var creditGreaterThan = this.creditGreaterThanTxField.value();
                var creditLessThan = this.creditLessThanTxField.value();
                ruleParams['CreditBalanceGreaterThan'] = creditGreaterThan;
                ruleParams['CreditBalanceLessThan'] = creditLessThan;
            }
            return ruleParams;
        };
        NotificationAddEditBladeViewModel.prototype._initializeFormFields = function (container) {
            var _this = this;
            var customValidation = new MsPortalFx.ViewModels.CustomValidation("", (function (value) {
                var validResult = true;
                var errorMessage = "";
                if (value == "UsageExceedsValue") {
                    _this.subscriptionsDdownField.disabled(false);
                    _this.creditGreaterThanTxField.disabled(true);
                    _this.creditLessThanTxField.disabled(true);
                    _this.usageExceedTxField.disabled(false);
                    _this.isDisableCreditFields(true);
                }
                else {
                    _this.subscriptionsDdownField.disabled(true);
                    _this.subscriptionsDdownField.value(null);
                    _this.creditGreaterThanTxField.disabled(false);
                    _this.creditLessThanTxField.disabled(false);
                    _this.usageExceedTxField.disabled(true);
                    _this.isDisableCreditFields(false);
                    _this.selectedSubscriptionId(_this.firstSubscriptionId());
                }
                return Q({
                    valid: validResult,
                    message: errorMessage,
                });
            }));
            var subscriptionDdownOptions = {
                label: ko.observable("Subscription Id"),
                options: ko.observableArray([{
                        text: ko.observable("Loading.."), value: ""
                    }]),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.subscriptionsDdownField = new MsPortalFx.ViewModels.Obsolete.Forms.DropDown.ViewModel(container, subscriptionDdownOptions);
            this.subscriptionsDdownField.value.subscribe(container, function (newSubscriptionId) {
                _this.selectedSubscriptionId(newSubscriptionId);
            });
            var displayNameTxFieldOptions = {
                label: ko.observable("Display Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.displayNameTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, displayNameTxFieldOptions);
            var emailIdsTxFieldOptions = {
                label: ko.observable("Email Ids"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation("^$|^\\b[A-Za-z0-9._%-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,4}\\b", "Invalid Email Address")
                ]),
            };
            this.emailIdsTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, emailIdsTxFieldOptions);
            var eventsDdownFieldOptions = {
                label: ko.observable('Event'),
                options: ko.observableArray([
                    { text: ko.observable("Usage Exceed Checker"), value: "UsageExceedsValue" },
                    { text: ko.observable("Credit Checker"), value: "LowCreditValue" }
                ]),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                    customValidation
                ]),
            };
            this.eventsDdownField = new MsPortalFx.ViewModels.Obsolete.Forms.DropDown.ViewModel(container, eventsDdownFieldOptions);
            var isRuleEnabledOption = {
                label: ko.observable("Enable Rule ?"),
                options: ko.observableArray([
                    { text: ko.observable("Yes"), value: true },
                    { text: ko.observable("No"), value: false }
                ]),
            };
            this.isRuleEnabledOptionField = new FxForms.OptionsGroup.ViewModel(container, isRuleEnabledOption);
            var usageExceedTxFieldOptions = {
                label: ko.observable("Usage Limit Value"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
                decimalPoint: ko.observable(10),
            };
            this.usageExceedTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, usageExceedTxFieldOptions);
            var creditGreaterThanTxFieldOptions = {
                label: ko.observable("Credit Greater Than"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
                decimalPoint: ko.observable(10),
            };
            this.creditGreaterThanTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, creditGreaterThanTxFieldOptions);
            var creditLessThanTxFieldOptions = {
                label: ko.observable("Credit Less Than"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
                decimalPoint: ko.observable(10),
            };
            this.creditLessThanTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, creditLessThanTxFieldOptions);
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.eventsDdownField,
                    this.displayNameTxField,
                    this.emailIdsTxField,
                    this.isRuleEnabledOptionField,
                    this.subscriptionsDdownField,
                    this.usageExceedTxField,
                    this.creditGreaterThanTxField,
                    this.creditLessThanTxField,
                ])
            });
        };
        NotificationAddEditBladeViewModel.prototype._setFormFields = function (data) {
            this.displayNameTxField.value(data.DisplayName.toString());
            this.emailIdsTxField.value(data.NotificationEmails.toString());
            this.eventsDdownField.value(data.RuleProviderId.toString());
            this.isRuleEnabledOptionField.value(data.IsEnabled);
            this.usageExceedTxField.value(data.RuleParams.Value);
            this.creditGreaterThanTxField.value(data.RuleParams.CreditBalanceGreaterThan);
            this.creditLessThanTxField.value(data.RuleParams.CreditBalanceLessThan);
        };
        NotificationAddEditBladeViewModel.prototype._updateSubscriptionsDdownField = function () {
            var _this = this;
            this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                _this.firstSubscriptionId(subscriptions.first().subscriptionId);
                var dropdownValues = subscriptions.map(function (s) {
                    return {
                        text: ko.observable(s.uniqueDisplayName),
                        value: s.subscriptionId,
                        disabled: ko.observable(false)
                    };
                });
                dropdownValues.unshift({
                    text: ko.observable("Select a subscription..."),
                    value: null,
                    disabled: ko.observable(false)
                });
                _this.subscriptionsDdownField.options(dropdownValues);
                if (_this.selectedRule().SubscriptionId) {
                    _this.subscriptionsDdownField.value(_this.selectedRule().SubscriptionId.toString());
                }
                else {
                    _this.subscriptionsDdownField.value(null);
                }
            });
        };
        NotificationAddEditBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            this.isAdd(inputs.isAdd);
            this.selectedRule(inputs.selectedRule);
            var title = this.isAdd() ? "Create new Rule" : "Edit Rule";
            this.title(title);
            this.description(title);
            if (!this.isAdd()) {
                this.eventsDdownField.disabled(true);
                this.subscriptionsDdownField.disabled(true);
                if (inputs.selectedRule.RuleProviderId == "UsageExceedsValue") {
                    this.creditGreaterThanTxField.disabled(true);
                    this.creditLessThanTxField.disabled(true);
                }
                else {
                    this.usageExceedTxField.disabled(true);
                }
            }
            this._updateSubscriptionsDdownField();
            var data = NotificationsModel.NotificationRulesOutModel.getNotificationRulesOutData(this.selectedRule());
            this._setFormFields(data);
            return Q();
        };
        return NotificationAddEditBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.NotificationAddEditBladeViewModel = NotificationAddEditBladeViewModel;
});
