var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "../../../Shared/Helpers"], function (require, exports, Helpers) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var Dialogs = MsPortalFx.ViewModels.Dialogs;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    "use strict";
    var NotificationMessagesBladeViewModel = (function (_super) {
        __extends(NotificationMessagesBladeViewModel, _super);
        function NotificationMessagesBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this.subscriptionId = ko.observable();
            _this.location = ko.observable("local");
            _this.notificationsList = ko.observableArray([]);
            _this.selectedMessage = ko.pureComputed(function () {
                return _this.notificationsGrid.selectableData.selectedItems().first();
            });
            _this.title("Messages");
            _this._container = container;
            _this._dataContext = dataContext;
            ko.reactor(container, function () {
            });
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1,
                    activateOnSelected: ko.observable(false)
                }
            };
            _this.notificationsGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var dateTimeFormat = Helpers.getTimeFormat(false, true);
            var basicColumns = [
                {
                    itemKey: "Title",
                    name: ko.observable("Title"),
                    width: ko.observable("80px"),
                    activatable: ko.observable(true),
                    format: FxGrid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: Helpers.getGridNameActivatableTemplate(),
                        htmlBindingsType: FxGrid.HtmlBindingsType.Default
                    }
                },
                {
                    itemKey: "SubscriptionID",
                    name: ko.observable("Subscription Id"),
                    width: ko.observable("120px"),
                },
                {
                    itemKey: "SubscriptionName",
                    name: ko.observable("Subscription Name"),
                    width: ko.observable("120px"),
                },
                {
                    itemKey: "Description",
                    name: ko.observable("Description"),
                    width: ko.observable("120px"),
                },
                {
                    itemKey: "IsDismissed",
                    name: ko.observable("Is Active"),
                    width: ko.observable("50px"),
                },
                {
                    itemKey: "LevelString",
                    name: ko.observable("Level"),
                    width: ko.observable("50px"),
                },
                {
                    itemKey: "TimestampString",
                    name: ko.observable("Time Stamp"),
                    width: ko.observable("50px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.CustomDate,
                    formatOptions: {
                        dateFormat: dateTimeFormat
                    }
                },
            ];
            _this.notificationsGrid.columns = ko.observableArray(basicColumns);
            _this.notificationsGrid.showHeader = true;
            _this.notificationsGrid.summary = ko.observable("Summary");
            _this.notificationsGrid.noRowsMessage("No items found");
            _this.notificationsList.subscribe(container, function (notifications) {
                _this.notificationsGrid.items(notifications);
            });
            _this._setupCommandBar();
            return _this;
        }
        NotificationMessagesBladeViewModel.prototype._setupCommandBar = function () {
            this._dismissNotificationButton = this._createDismissNotificationButton();
            this._deleteNotificationButton = this._createDeleteNotificationButton();
            this._clearAllNotificationButton = this._createClearAllNotificationButton();
            this._refreshButton = this._createRefreshButton();
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([
                this._dismissNotificationButton,
                this._deleteNotificationButton,
                this._refreshButton,
            ]);
        };
        NotificationMessagesBladeViewModel.prototype._createRefreshButton = function () {
            var _this = this;
            var refreshButton = new FxToolbars.CommandButton({
                label: "Refresh",
                icon: MsPortalFx.Base.Images.Refresh(),
                command: {
                    canExecute: ko.computed(this._container, function () {
                        return _this.selectedMessage() != null;
                    }),
                    execute: function (result) {
                        return _this._getNotifications();
                    }
                }
            });
            return refreshButton;
        };
        NotificationMessagesBladeViewModel.prototype._createDismissNotificationButton = function () {
            var _this = this;
            var dismissButton = new FxToolbars.DialogButton({
                label: "Dismiss",
                icon: MsPortalFx.Base.Images.Disable(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure you want to dismiss the selected notification message ?", 4),
            });
            dismissButton.command = {
                canExecute: ko.computed(this._container, function () {
                    return _this.selectedMessage() != null;
                }),
                execute: function (result) {
                    if (result === 6) {
                        _this._dataContext.sharedContext.notificationsDataManager.dismissNotificationQuery(_this.subscriptionId(), _this.location(), _this.selectedMessage().Id);
                    }
                    return null;
                }
            };
            return dismissButton;
        };
        NotificationMessagesBladeViewModel.prototype._createDeleteNotificationButton = function () {
            var _this = this;
            var deleteButton = new FxToolbars.DialogButton({
                label: "Delete",
                icon: MsPortalFx.Base.Images.Delete(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure you want to delete the selected notification message ?", 4),
            });
            deleteButton.command = {
                canExecute: ko.computed(this._container, function () {
                    return _this.selectedMessage() != null;
                }),
                execute: function (result) {
                    if (result === 6) {
                        _this._dataContext.sharedContext.notificationsDataManager.deleteNotificationQuery(_this.subscriptionId(), _this.location(), _this.selectedMessage().Id);
                    }
                    return null;
                }
            };
            return deleteButton;
        };
        NotificationMessagesBladeViewModel.prototype._createClearAllNotificationButton = function () {
            var _this = this;
            var clearButton = new FxToolbars.DialogButton({
                label: "Clear All",
                icon: MsPortalFx.Base.Images.Clock(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure you want to clear all notification message ?", 4),
            });
            clearButton.command = {
                canExecute: ko.observable(true),
                execute: function (result) {
                    if (result === 6) {
                        _this._dataContext.sharedContext.notificationsDataManager.clearAllNotificationsQuery(_this.subscriptionId(), _this.location());
                    }
                    return null;
                }
            };
            return clearButton;
        };
        NotificationMessagesBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            return this._getNotifications();
        };
        NotificationMessagesBladeViewModel.prototype._getNotifications = function () {
            var _this = this;
            return this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                _this.subscriptionId(subscriptions.first().subscriptionId);
                _this.notificationsGrid.loading(true);
                var subscriptionIds = _this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
                var q = _this._dataContext.sharedContext.notificationsDataManager.getNotifications(subscriptionIds[0], subscriptionIds)
                    .then(function (notifications) {
                    for (var _i = 0, notifications_1 = notifications; _i < notifications_1.length; _i++) {
                        var item = notifications_1[_i];
                        item.SubscriptionName = ko.observable(subscriptions.first(function (i) { return i.subscriptionId == item.SubscriptionID; }).uniqueDisplayName);
                    }
                    _this.notificationsList(notifications);
                    _this.notificationsGrid.loading(false);
                });
                return q;
            });
        };
        return NotificationMessagesBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.NotificationMessagesBladeViewModel = NotificationMessagesBladeViewModel;
});
