var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "../../../Shared/Helpers", "../../../_generated/BladeReferences"], function (require, exports, Helpers, BladeReferences) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var Dialogs = MsPortalFx.ViewModels.Dialogs;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    "use strict";
    var NotificationRulesBladeViewModel = (function (_super) {
        __extends(NotificationRulesBladeViewModel, _super);
        function NotificationRulesBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this.subscriptionId = ko.observable();
            _this.location = ko.observable("local");
            _this.notificationRulesList = ko.observableArray([]);
            _this.selectedRule = ko.pureComputed(function () {
                return _this.notificationRulesGrid.selectableData.selectedItems().first();
            });
            _this.title("Messages");
            _this._container = container;
            _this._dataContext = dataContext;
            ko.reactor(container, function () {
            });
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1,
                    activateOnSelected: ko.observable(false)
                }
            };
            _this.notificationRulesGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var dateTimeFormat = Helpers.getTimeFormat(false, true);
            var basicColumns = [
                {
                    itemKey: "Id",
                    name: ko.observable("Id"),
                    width: ko.observable("50px"),
                },
                {
                    itemKey: "SubscriptionName",
                    name: ko.observable("Subscription"),
                    width: ko.observable("120px"),
                },
                {
                    itemKey: "DisplayName",
                    name: ko.observable("Name"),
                    width: ko.observable("120px"),
                },
                {
                    itemKey: "RuleProviderId",
                    name: ko.observable("Event"),
                    width: ko.observable("50px"),
                },
                {
                    itemKey: "Status",
                    name: ko.observable("Status"),
                    width: ko.observable("50px"),
                },
                {
                    itemKey: "NextCheck",
                    name: ko.observable("Next Check"),
                    width: ko.observable("50px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.CustomDate,
                    formatOptions: {
                        dateFormat: dateTimeFormat
                    }
                },
                {
                    itemKey: "LastTriggerAt",
                    name: ko.observable("Last Trigger At"),
                    width: ko.observable("50px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.CustomDate,
                    formatOptions: {
                        dateFormat: dateTimeFormat
                    }
                },
            ];
            _this.notificationRulesGrid.columns = ko.observableArray(basicColumns);
            _this.notificationRulesGrid.showHeader = true;
            _this.notificationRulesGrid.summary = ko.observable("Summary");
            _this.notificationRulesGrid.noRowsMessage("No items found");
            _this.notificationRulesList.subscribe(container, function (notificationRules) {
                _this.notificationRulesGrid.items(notificationRules);
            });
            _this._setupCommandBar();
            return _this;
        }
        NotificationRulesBladeViewModel.prototype._setupCommandBar = function () {
            this._addNotificationRuleButton = this._createAddRuleButton();
            this._editNotificationRuleButton = this._createEditRuleButton();
            this._deleteNotificationRuleButton = this._createDeleteNotificationRuleButton();
            this._refreshButton = this._createRefreshButton();
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([
                this._addNotificationRuleButton,
                this._editNotificationRuleButton,
                this._deleteNotificationRuleButton,
                this._refreshButton,
            ]);
        };
        NotificationRulesBladeViewModel.prototype._getNewNotificationRule = function () {
            var ruleParams = {};
            ruleParams['Value'] = '0';
            ruleParams['Resource'] = 'TotalCost';
            ruleParams['CreditBalanceGreaterThan'] = '0';
            ruleParams['CreditBalanceLessThan'] = '0';
            return {
                SubscriptionId: '',
                Id: 0,
                RuleProviderId: '',
                DisplayName: '',
                NotificationEmails: '',
                IsEnabled: true,
                RuleParams: ruleParams
            };
        };
        NotificationRulesBladeViewModel.prototype._getSelectedNotificationRule = function () {
            var ruleParams = {};
            ruleParams['Value'] = this.selectedRule().RuleParams.Value;
            ruleParams['CreditBalanceGreaterThan'] = this.selectedRule().RuleParams.CreditBalanceGreaterThan;
            ruleParams['CreditBalanceLessThan'] = this.selectedRule().RuleParams.CreditBalanceLessThan;
            return {
                SubscriptionId: this.selectedRule().SubscriptionId,
                Id: this.selectedRule().Id,
                RuleProviderId: this.selectedRule().RuleProviderId,
                DisplayName: this.selectedRule().DisplayName,
                NotificationEmails: this.selectedRule().NotificationEmails,
                IsEnabled: this.selectedRule().IsEnabled,
                RuleParams: ruleParams
            };
        };
        NotificationRulesBladeViewModel.prototype._createRefreshButton = function () {
            var _this = this;
            var refreshButton = new FxToolbars.CommandButton({
                label: "Refresh",
                icon: MsPortalFx.Base.Images.Refresh(),
                command: {
                    canExecute: ko.observable(true),
                    execute: function (result) {
                        return _this._getNotificationRules();
                    }
                }
            });
            return refreshButton;
        };
        NotificationRulesBladeViewModel.prototype._createAddRuleButton = function () {
            var _this = this;
            var addButton = new FxToolbars.CommandButton({
                label: "Add",
                icon: MsPortalFx.Base.Images.Add(),
                command: {
                    execute: function () {
                        return _this._container.openBlade(new BladeReferences.NotificationAddEditBladeReference({
                            isAdd: true,
                            selectedRule: _this._getNewNotificationRule(),
                        }));
                    },
                    canExecute: ko.observable(true),
                }
            });
            return addButton;
        };
        NotificationRulesBladeViewModel.prototype._createEditRuleButton = function () {
            var _this = this;
            var editButton = new FxToolbars.CommandButton({
                label: "Edit",
                icon: MsPortalFx.Base.Images.Edit(),
                command: {
                    execute: function () {
                        return _this._container.openBlade(new BladeReferences.NotificationAddEditBladeReference({
                            isAdd: false,
                            selectedRule: _this._getSelectedNotificationRule(),
                        }));
                    },
                    canExecute: ko.computed(this._container, function () {
                        return _this.selectedRule() != null;
                    }),
                }
            });
            return editButton;
        };
        NotificationRulesBladeViewModel.prototype._createDeleteNotificationRuleButton = function () {
            var _this = this;
            var deleteButton = new FxToolbars.DialogButton({
                label: "Delete",
                icon: MsPortalFx.Base.Images.Delete(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure you want to delete the selected notification rule ?", 4),
            });
            deleteButton.command = {
                canExecute: ko.computed(this._container, function () {
                    return _this.selectedRule() != null;
                }),
                execute: function (result) {
                    if (result === 6) {
                        _this._dataContext.sharedContext.notificationsDataManager.deleteNotificationRuleQuery(_this.selectedRule().SubscriptionId, _this.location(), _this.selectedRule().Id);
                    }
                    return null;
                }
            };
            return deleteButton;
        };
        NotificationRulesBladeViewModel.prototype._createClearAllNotificationRuleButton = function () {
            var _this = this;
            var clearButton = new FxToolbars.DialogButton({
                label: "Clear All",
                icon: MsPortalFx.Base.Images.Clock(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure you want to clear all notification rules ?", 4),
            });
            clearButton.command = {
                canExecute: ko.observable(true),
                execute: function (result) {
                    if (result === 6) {
                        _this._dataContext.sharedContext.notificationsDataManager.clearAllNotificationRuleQuery(_this.selectedRule().SubscriptionId, _this.location());
                    }
                    return null;
                }
            };
            return clearButton;
        };
        NotificationRulesBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            return this._getNotificationRules();
        };
        NotificationRulesBladeViewModel.prototype._getNotificationRules = function () {
            var _this = this;
            return this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                _this.subscriptionId(subscriptions.first().subscriptionId);
                _this.notificationRulesGrid.loading(true);
                var subscriptionIds = _this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
                var q = _this._dataContext.sharedContext.notificationsDataManager.getNotificationRules(subscriptionIds[0], subscriptionIds)
                    .then(function (notificationRules) {
                    var _loop_1 = function (item) {
                        item.SubscriptionName = ko.observable(subscriptions.first(function (i) { return i.subscriptionId == item.SubscriptionId; }).uniqueDisplayName);
                    };
                    for (var _i = 0, notificationRules_1 = notificationRules; _i < notificationRules_1.length; _i++) {
                        var item = notificationRules_1[_i];
                        _loop_1(item);
                    }
                    _this.notificationRulesList(notificationRules);
                    _this.notificationRulesGrid.loading(false);
                });
                return q;
            });
        };
        return NotificationRulesBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.NotificationRulesBladeViewModel = NotificationRulesBladeViewModel;
});
