var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "../../../_generated/ExtensionDefinition", "../../../Shared/Helpers"], function (require, exports, ExtensionDefinition, Helpers) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var PartViewModels = MsPortalFx.ViewModels.Parts;
    var FxTextProperty = MsPortalFx.ViewModels.Parts.Properties.TextProperty;
    "use strict";
    var BillingOverviewResourceSummaryViewModel = (function (_super) {
        __extends(BillingOverviewResourceSummaryViewModel, _super);
        function BillingOverviewResourceSummaryViewModel(container, initialState, dataContext) {
            var _this = _super.call(this, initialState, BillingOverviewResourceSummaryViewModel._getOptions(container), container) || this;
            _this._userOverview = ko.observable();
            _this._container = container;
            _this._dataContext = dataContext;
            ko.reactor(container, function () {
                if (_this._userOverview()) {
                    _this.removeAllProperties();
                    _this._addProperties(_this._userOverview(), _this._container);
                }
            });
            return _this;
        }
        BillingOverviewResourceSummaryViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            var q1 = _super.prototype.onInputsSet.call(this, inputs, settings);
            var subIds = this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
            if (subIds.length === 0)
                return Q();
            var q2 = this._dataContext.sharedContext.billingOverviewManager.getBillingUserOverview(subIds).then(function (overview) {
                var overviewObs = Helpers.makeObservable($.extend({}, overview, {}));
                _this._userOverview(overviewObs());
            });
            return Q.all([q1, q2]);
        };
        BillingOverviewResourceSummaryViewModel.prototype._addProperties = function (userOverview, container) {
            if (!userOverview)
                console.log("Overview Blade: Data is null");
            var isLoading = ko.observable(false);
            var properties = [
                new FxTextProperty({
                    label: "Account Admin",
                    value: userOverview.UserId,
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Current Bill Amount",
                    value: userOverview.CurrentBillAmountString,
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Current Billing Period",
                    value: userOverview.BillingPeriodString,
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Estimated Bill Amount",
                    value: userOverview.EstimatedBillAmountString,
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Days left",
                    value: userOverview.DaysRemainingInBillingCycle,
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Billing country/region",
                    value: userOverview.Region,
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Active Notifications",
                    value: userOverview.ActiveNotificationsCount,
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Currency",
                    value: userOverview.CurrencySymbol,
                    isLoading: isLoading
                }),
            ];
            this.setProperties(properties);
        };
        BillingOverviewResourceSummaryViewModel._getOptions = function (container) {
            var getQuickStartSelection = function (inputs) {
                return {
                    detailBlade: ExtensionDefinition.BladeNames.billingOverviewBlade,
                    detailBladeInputs: {
                        id: inputs.resourceId
                    }
                };
            };
            var getAllSettingsSelection = function (inputs) {
                return {
                    detailBlade: ExtensionDefinition.BladeNames.billingOverviewSettingsListBlade,
                    detailBladeInputs: {
                        id: inputs.resourceId
                    }
                };
            };
            var getKeysSelection = function (inputs) {
                return {
                    detailBlade: ExtensionDefinition.BladeNames.billingOverviewPropertiesBlade,
                    detailBladeInputs: {
                        id: inputs.resourceId
                    }
                };
            };
            var isLoading = ko.observable(false);
            var properties = [];
            return {
                getSettingsSelection: getAllSettingsSelection,
                getKeysSelection: getKeysSelection,
                collapsed: false,
                supportsResourceMove: 4,
                noResourceGroup: true
            };
        };
        return BillingOverviewResourceSummaryViewModel;
    }(PartViewModels.ResourceSummary.ViewModel));
    exports.BillingOverviewResourceSummaryViewModel = BillingOverviewResourceSummaryViewModel;
});
