var _stripe = document.createElement('script');
_stripe.src = 'https://js.stripe.com/v3/';
document.head.appendChild(_stripe);
var StripeTokenHelper = (function () {
    function StripeTokenHelper() {
        var _this = this;
        var stripePublicKey = localStorage["StripePublicKey"];
        var stripe = Stripe(stripePublicKey);
        var elements = stripe.elements();
        var card = elements.create('card');
        var cardElements = document.getElementById('card-element');
        card.mount(cardElements);
        this.allObjects = { _Stripe: stripe, Elements: elements, Card: card };
        var generateTokenButton = document.getElementById('payInvoiceButton');
        generateTokenButton.addEventListener("click", function (e) { return _this.generateToken(); });
    }
    StripeTokenHelper.prototype.generateToken = function () {
        var cardHolderName = document.getElementById('stripe-cardHolderName').value;
        this.allObjects.data = { name: cardHolderName };
        this.allObjects._Stripe.createToken(this.allObjects.Card, this.allObjects.data).then(function (result) {
            if (result.error) {
                localStorage["IsStripeTokenError"] = true;
                localStorage["StripeTokenErrorMessage"] = result.error.message;
                window.close();
            }
            else {
                localStorage["StripeToken"] = JSON.stringify(result.token);
                window.close();
            }
        });
    };
    return StripeTokenHelper;
}());
window.onload = function () {
    var stripeCard = new StripeTokenHelper();
};
