var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "../../../Shared/Helpers"], function (require, exports, Helpers) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var PartViewModels = MsPortalFx.ViewModels.Parts;
    var FxTextProperty = MsPortalFx.ViewModels.Parts.Properties.TextProperty;
    "use strict";
    var getOptions = function (container) {
        var isLoading = ko.observable(false);
        var properties = [];
        return {
            collapsed: false,
            supportsResourceMove: 4,
            noResourceGroup: true
        };
    };
    var SubscriptionOverviewResourceSummaryViewModel = (function (_super) {
        __extends(SubscriptionOverviewResourceSummaryViewModel, _super);
        function SubscriptionOverviewResourceSummaryViewModel(container, initialState, dataContext) {
            var _this = _super.call(this, initialState, getOptions(container), container) || this;
            _this.subscriptionId = ko.observable();
            _this.billingPeriod = ko.observable();
            _this._subscriptionOverviewData = ko.observable();
            _this._subscriptionAndOfferDetails = ko.observable();
            _this._container = container;
            _this._dataContext = dataContext;
            ko.reactor(container, function () {
                if (_this._subscriptionOverviewData() && _this._subscriptionAndOfferDetails()) {
                    _this.removeAllProperties();
                    _this._addProperties(_this._subscriptionOverviewData(), _this._subscriptionAndOfferDetails(), container);
                }
            });
            return _this;
        }
        SubscriptionOverviewResourceSummaryViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.subscriptionId(inputs.resourceId);
            this.billingPeriod(inputs.billingPeriod);
            var subIds = this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
            var q1 = _super.prototype.onInputsSet.call(this, inputs, settings);
            var q2;
            if (this.billingPeriod()) {
                q2 = this._dataContext.sharedContext.billingOverviewManager.getSubscriptionOverviewForBillingPeriod(subIds, this.billingPeriod().Month, this.billingPeriod().Year);
            }
            else {
                q2 = this._dataContext.sharedContext.billingOverviewManager.getSubscriptionOverview(subIds);
            }
            q2 = q2.then(function (overview) {
                var overviewObs = Helpers.makeObservable(overview);
                _this._subscriptionOverviewData(overviewObs());
            });
            var q3 = this._dataContext.sharedContext.subscriptionsManager.getSubscriptionAndOfferDetails(this.subscriptionId()).then(function (subAndOfferDetails) {
                var subAndOfferDetailsObs = Helpers.makeObservable(subAndOfferDetails);
                _this._subscriptionAndOfferDetails(subAndOfferDetailsObs());
            });
            return Q.all([q1, q2, q3]);
        };
        SubscriptionOverviewResourceSummaryViewModel.prototype._addProperties = function (subscriptionModel, subAndOfferDetails, container) {
            if (!subscriptionModel)
                console.log("Overview Blade: asset param is null");
            var isLoading = ko.observable(false);
            var properties = [
                new FxTextProperty({
                    label: "Subscription Id",
                    value: subscriptionModel.SubscriptionId,
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Subscription Name",
                    value: ko.computed(container, function () {
                        return subAndOfferDetails.SubscriptionDisplayName();
                    }),
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Offer Id",
                    value: ko.computed(container, function () {
                        return subAndOfferDetails.OfferId();
                    }),
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Offer Name",
                    value: ko.computed(container, function () {
                        return subAndOfferDetails.OfferDisplayName();
                    }),
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Currency",
                    value: ko.computed(container, function () {
                        return subscriptionModel.Currency();
                    }),
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "State",
                    value: ko.computed(container, function () {
                        return subAndOfferDetails.SubscriptionState();
                    }),
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Current billing period",
                    value: ko.computed(container, function () {
                        return subscriptionModel.BillingPeriod();
                    }),
                    isLoading: isLoading
                }),
            ];
            this.setProperties(properties);
        };
        return SubscriptionOverviewResourceSummaryViewModel;
    }(PartViewModels.ResourceSummary.ViewModel));
    exports.SubscriptionOverviewResourceSummaryViewModel = SubscriptionOverviewResourceSummaryViewModel;
});
