var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "../../../Shared/Helpers"], function (require, exports, Helpers) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxDropDown = MsPortalFx.ViewModels.Obsolete.Forms.DropDown;
    var FxControls = MsPortalFx.ViewModels.Controls;
    var FileDownload = MsPortalFx.ViewModels.Controls.FileDownload;
    var FileDownloadButton = MsPortalFx.ViewModels.Controls.FileDownloadButton;
    "use strict";
    var UsageAndQuotaSnapInBladeViewModel = (function (_super) {
        __extends(UsageAndQuotaSnapInBladeViewModel, _super);
        function UsageAndQuotaSnapInBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this.subscriptionIdIn = ko.observable();
            _this.subscriptionIdList = ko.observableArray([]);
            _this.periodList = ko.observableArray([]);
            _this.allProviderList = ko.observableArray([]);
            _this.allResourceList = ko.observableArray([]);
            _this.selectedPeriod = ko.observable();
            _this.selectedProvider = ko.observable();
            _this.selectedResource = ko.observable();
            _this.selectedSubscriptionId = ko.observable("local");
            _this.totalBillableCost = ko.observable(0);
            _this.downloadUri = ko.observable();
            _this.inputData = ko.observable();
            _this.billingIcon = MsPortalFx.Base.Images.Polychromatic.BillingHub();
            _this.title = ko.observable("Monthly Summary");
            _this.icon = ko.observable(MsPortalFx.Base.Images.Clock());
            _this._container = container;
            _this._dataContext = dataContext;
            _this._initFiltersAndButtonsSection(container);
            var gridExtensions = FxGridExtensions.Filterable | FxGridExtensions.SortableColumn | FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                filterable: {
                    searchBoxCloseButtonVisible: ko.observable(false),
                    searchBoxPlaceholder: ko.observable("Search to filter items..."),
                    searchBoxVisible: ko.observable(true),
                    searchableColumns: ko.observableArray(["QuotaResourceDisplayName", "QuotaProvider", "ConsumptionPercentage"])
                },
                selectableRow: {
                    selectionMode: 1
                }
            };
            _this.quotaUsageGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    itemKey: "QuotaResourceDisplayName",
                    name: ko.observable("Quota Resource"),
                    activatable: ko.observable(false)
                },
                {
                    itemKey: "QuotaProvider",
                    name: ko.observable("Provider"),
                    activatable: ko.observable(true)
                },
                {
                    itemKey: "ConsumptionPercentage",
                    name: ko.observable("Consumption Percentage"),
                    format: FxGrid.Format.PercentageBar,
                    formatOptions: {
                        percentageBar: {
                            barColorKey: "i0t1",
                            backgroundColor: "paletteLightGray",
                            textLocation: 1
                        },
                    }
                },
                {
                    itemKey: "QuotaUsageString",
                    name: ko.observable("Quota Usage"),
                },
            ];
            _this.quotaUsageGrid.columns = ko.observableArray(basicColumns);
            _this.quotaUsageGrid.showHeader = true;
            _this.quotaUsageGrid.summary = ko.observable("Summary");
            _this.quotaUsageGrid.noRowsMessage("No items found");
            _this.quotaUsageGrid.selectableData.selectableItems.subscribe(container, function () {
                _this.downloadAzSQuotaSummaryButton = _this._createDownloadButtonViewModel();
            });
            return _this;
        }
        UsageAndQuotaSnapInBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.subscriptionIdList(this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList);
            this.subscriptionIdIn(this.subscriptionIdList().first());
            var q1 = this._dataContext.sharedContext.usageAndQuotaDataManager.getAzSQuotaFilters(this.subscriptionIdIn(), this.subscriptionIdList()).then(function (filters) {
                var resourceList = [];
                var providers = Object.keys(filters.Resources);
                _this.allProviderList(providers);
                var providerDropdownValues = providers.map(function (mr) {
                    return {
                        text: ko.observable(mr),
                        value: mr,
                        disabled: ko.observable(false)
                    };
                });
                providerDropdownValues.unshift({
                    text: ko.observable("All Providers"),
                    value: "-1",
                    disabled: ko.observable(false)
                });
                _this.providerDropDown.options(providerDropdownValues);
                _this.providerDropDown.value("-1");
                _this.providerDropDown.disabled(false);
                Object.keys(filters.Resources).forEach(function (key) {
                    resourceList = resourceList.concat(filters.Resources[key]);
                });
                _this.allResourceList(resourceList);
                var resourcesDropdownValues = resourceList.map(function (mr) {
                    return {
                        text: ko.observable(mr),
                        value: mr,
                        disabled: ko.observable(false)
                    };
                });
                resourcesDropdownValues.unshift({
                    text: ko.observable("All Quota Resources"),
                    value: "-1",
                    disabled: ko.observable(false)
                });
                _this.resourcesDropDown.options(resourcesDropdownValues);
                _this.resourcesDropDown.value("-1");
                _this.resourcesDropDown.disabled(false);
                var periodDropdownValues = filters.BillingCyclePeriods.map(function (mr) {
                    _this.periodList.push(mr);
                    return {
                        text: ko.observable(mr.Label),
                        value: mr,
                        disabled: ko.observable(false)
                    };
                });
                periodDropdownValues.unshift({
                    text: ko.observable("Select a Period"),
                    value: "-1",
                    disabled: ko.observable(false)
                });
                _this.periodDropDown.options(periodDropdownValues);
                _this.periodDropDown.value(filters.BillingCyclePeriods.first(function (p) { return p.IsCurrent; }));
                _this.periodDropDown.disabled(false);
            });
            var q2 = this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                var dropdownValues = subscriptions.map(function (s) {
                    return {
                        text: ko.observable(s.uniqueDisplayName),
                        value: s.subscriptionId,
                        disabled: ko.observable(false)
                    };
                });
                dropdownValues.unshift({
                    text: ko.observable("Please select a subscription..."),
                    value: null,
                    disabled: ko.observable(false)
                });
                _this.subscriptionsDropDown.options(dropdownValues);
                if (_this.subscriptionIdIn()) {
                    _this.subscriptionsDropDown.value(_this.subscriptionIdIn());
                }
                else {
                    _this.subscriptionsDropDown.value(null);
                }
            });
            return Q.all([q1, q2]).then(function () {
                _this._onApplyButtonClicked();
            });
        };
        UsageAndQuotaSnapInBladeViewModel.prototype._initFiltersAndButtonsSection = function (container) {
            var _this = this;
            var subscriptionDropDownOptions = {
                label: ko.observable("Subscription"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose a Subscription"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.subscriptionsDropDown = new FxDropDown.ViewModel(container, subscriptionDropDownOptions);
            this.subscriptionsDropDown.value.subscribe(container, function (newSubscriptionId) {
                _this.selectedSubscriptionId(newSubscriptionId);
            });
            var quotaResourceDropDownOptions = {
                label: ko.observable("Quota Resource"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose the Resource"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.resourcesDropDown = new FxDropDown.ViewModel(container, quotaResourceDropDownOptions);
            this.resourcesDropDown.value.subscribe(container, function (resource) {
                _this.selectedResource(resource);
            });
            var quotaProviderDropDownOptions = {
                label: ko.observable("Quota Provider"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose a Provider"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.providerDropDown = new FxDropDown.ViewModel(container, quotaProviderDropDownOptions);
            this.providerDropDown.value.subscribe(container, function (provider) {
                _this.selectedProvider(provider);
                _this._dataContext.sharedContext.usageAndQuotaDataManager.getQuotaResourcesForProvider(_this.selectedSubscriptionId(), provider)
                    .then(function (resourceList) {
                    _this.allResourceList(resourceList);
                    var resourcesDropdownValues = resourceList.map(function (resource) {
                        return {
                            text: ko.observable(resource),
                            value: resource,
                            disabled: ko.observable(false)
                        };
                    });
                    resourcesDropdownValues.unshift({
                        text: ko.observable("All Quota Resources"),
                        value: "-1",
                        disabled: ko.observable(false)
                    });
                    _this.resourcesDropDown.options(resourcesDropdownValues);
                    _this.resourcesDropDown.value("-1");
                    _this.resourcesDropDown.disabled(false);
                });
            });
            var periodDropDownOptions = {
                label: ko.observable("Period"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose a Period"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.periodDropDown = new FxDropDown.ViewModel(container, periodDropDownOptions);
            this.periodDropDown.value.subscribe(container, function (period) {
                _this.selectedPeriod(period);
            });
            this.applyFiltersButton = new FxControls.SimpleButton.ViewModel(container, {
                onClick: this._onApplyButtonClicked.bind(this),
                text: "Apply",
                primary: true,
            });
            this.downloadAzSQuotaSummaryButton = this._createDownloadButtonViewModel();
            var column1 = new MsPortalFx.ViewModels.Forms.Section.ViewModel(container, {
                style: ko.observable(0),
                children: ko.observableArray([
                    this.periodDropDown,
                    this.providerDropDown,
                ])
            });
            var column2 = new MsPortalFx.ViewModels.Forms.Section.ViewModel(container, {
                style: ko.observable(0),
                children: ko.observableArray([
                    this.subscriptionsDropDown,
                    this.resourcesDropDown,
                ])
            });
            this.filtersSection = new MsPortalFx.ViewModels.Forms.Section.ViewModel(container, {
                style: ko.observable(3),
                children: ko.observableArray([
                    column1, column2
                ])
            });
        };
        UsageAndQuotaSnapInBladeViewModel.prototype._onApplyButtonClicked = function () {
            var _this = this;
            this.quotaUsageGrid.loading(true);
            var subId = this.selectedSubscriptionId();
            if (this.periodList().first() != undefined) {
                var input = this._getInputParameter(subId);
                this._dataContext.sharedContext.usageAndQuotaDataManager.getAzSSnapInView(subId, input).then(function (quotaRecords) {
                    if (quotaRecords.length > 0) {
                        _this.quotaUsageGrid.items(quotaRecords.first().AzureStackQuotaResources);
                    }
                });
            }
            this.quotaUsageGrid.loading(false);
        };
        UsageAndQuotaSnapInBladeViewModel.prototype._getInputParameter = function (subId) {
            var provider = [];
            var resource = [];
            var subIdList = [];
            if (this.selectedPeriod() == undefined) {
                this.selectedPeriod(this.periodList().first());
            }
            if (this.selectedProvider() == "-1") {
                provider = this.allProviderList();
            }
            else {
                provider.push(this.selectedProvider());
            }
            if (this.selectedResource() == "-1") {
                resource = this.allResourceList();
            }
            else {
                resource.push(this.selectedResource());
            }
            subIdList.push(subId);
            var _st = new Date(this.selectedPeriod().StartDate);
            var _startDate = Helpers.getUtcDateString(_st);
            var _et = new Date(this.selectedPeriod().EndDate);
            var _endDate = Helpers.getUtcDateString(_et);
            var input = {
                SubscriptionIds: subIdList,
                QuotaProviderList: provider,
                QuotaResourceNames: resource,
                QuotaPeriod: { StartDate: _startDate, EndDate: _endDate, IsCurrent: this.selectedPeriod().IsCurrent },
            };
            return input;
        };
        UsageAndQuotaSnapInBladeViewModel.prototype._createDownloadButtonViewModel = function () {
            var subId = this.selectedSubscriptionId();
            var input;
            if (this.selectedPeriod() != undefined) {
                input = this._getInputParameter(subId);
            }
            var postData = ko.toJSON(input);
            this.inputData(postData);
            var args = {
                subscriptionId: subId,
                location: "local",
            };
            this.downloadUri(this._dataContext.sharedContext.usageAndQuotaDataManager.downloadAzSQuotaSummaryUri(args));
            var azsQuotaSummaryDownloadContext = new FileDownload.Context({
                targetUri: this.downloadUri,
                httpMethod: ko.observable("POST"),
                httpRequestContent: this.inputData,
                httpRequestContentType: ko.observable("application/json"),
                downloadType: ko.observable(2),
                addDefaultAuthorizationToken: true,
                showDownloadProgressDialog: ko.observable(true)
            });
            var downloadButtonViewModel = new FileDownloadButton.ViewModel(this._container, {
                context: ko.observable(azsQuotaSummaryDownloadContext),
                label: ko.observable("Download"),
                disabled: ko.observable(false),
            });
            return downloadButtonViewModel;
        };
        return UsageAndQuotaSnapInBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.UsageAndQuotaSnapInBladeViewModel = UsageAndQuotaSnapInBladeViewModel;
});
