var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "../../../Shared/Helpers"], function (require, exports, Helpers) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var UsageAndQuotaStatusGridPartViewModel = (function (_super) {
        __extends(UsageAndQuotaStatusGridPartViewModel, _super);
        function UsageAndQuotaStatusGridPartViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this.billingPeriod = ko.observable(null);
            _this.billingIcon = MsPortalFx.Base.Images.Polychromatic.BillingHub();
            _this.remainingCreditsText = ko.observable("");
            _this._monitorBillingPeriodDropDown = ko.observable(false);
            _this.isCurrentMonth = ko.observable(false);
            _this.subscriptionIdIn = ko.observable();
            _this.subscriptionIdList = ko.observableArray([]);
            _this.periodList = ko.observableArray([]);
            _this.allProviderList = ko.observableArray([]);
            _this.allResourceList = ko.observableArray([]);
            _this.location = ko.observable("local");
            _this.title("Quota Status");
            _this._container = container;
            _this._dataContext = dataContext;
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1
                }
            };
            _this.quotaStatusGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    itemKey: "SubscriptionId",
                    name: ko.observable("Subscription Id"),
                    activatable: ko.observable(false),
                },
                {
                    itemKey: "SubscriptionName",
                    name: ko.observable("Subscription Name"),
                    activatable: ko.observable(false)
                },
                {
                    itemKey: "OkStatus",
                    name: ko.observable("OK"),
                    format: FxGrid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div>" +
                            "<span style='color: forestgreen' data-bind='text: value'></span" +
                            "</div>",
                        htmlBindingsType: FxGrid.HtmlBindingsType.Default
                    }
                },
                {
                    itemKey: "WarningStatus",
                    name: ko.observable("Warning"),
                    format: FxGrid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div>" +
                            "<span style='color: orange' data-bind='text: value'></span" +
                            "</div>",
                        htmlBindingsType: FxGrid.HtmlBindingsType.Default
                    }
                },
                {
                    itemKey: "CriticalStatus",
                    name: ko.observable("Critical"),
                    format: FxGrid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div>" +
                            "<span style='color: red' data-bind='text: value'></span" +
                            "</div>",
                        htmlBindingsType: FxGrid.HtmlBindingsType.Default
                    }
                },
            ];
            _this.quotaStatusGrid.columns = ko.observableArray(basicColumns);
            _this.quotaStatusGrid.showHeader = true;
            _this.quotaStatusGrid.summary = ko.observable("Summary");
            _this.quotaStatusGrid.noRowsMessage("No items found");
            return _this;
        }
        UsageAndQuotaStatusGridPartViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            var subscriptionsDict = {};
            return this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                subscriptions.map(function (s) {
                    subscriptionsDict[s.subscriptionId] = s.displayName;
                });
                _this.subscriptionIdList(Object.keys(subscriptionsDict));
                _this.subscriptionIdIn(_this.subscriptionIdList().first());
                _this._dataContext.sharedContext.usageAndQuotaDataManager.getAzSQuotaFilters(_this.subscriptionIdIn(), _this.subscriptionIdList()).then(function (filters) {
                    var resourceList = [];
                    var providers = Object.keys(filters.Resources);
                    _this.allProviderList(providers);
                    Object.keys(filters.Resources).forEach(function (key) {
                        resourceList = resourceList.concat(filters.Resources[key]);
                    });
                    _this.allResourceList(resourceList);
                    var periods = [];
                    filters.BillingCyclePeriods.map(function (mr) {
                        periods.push(mr);
                    });
                    _this.periodList(periods);
                    var _st = new Date(_this.periodList().first().StartDate);
                    var _startDate = Helpers.getUtcDateString(_st);
                    var _et = new Date(_this.periodList().first().EndDate);
                    var _endDate = Helpers.getUtcDateString(_et);
                    var input = {
                        SubscriptionIds: _this.subscriptionIdList(),
                        QuotaProviderList: _this.allProviderList(),
                        QuotaResourceNames: _this.allResourceList(),
                        QuotaPeriod: { StartDate: _startDate, EndDate: _endDate, IsCurrent: true },
                    };
                    _this._dataContext.sharedContext.usageAndQuotaDataManager.getAzSSnapInView(_this.subscriptionIdList().first(), input).then(function (quotaRecords) {
                        var transformedQuotas = quotaRecords.map(function (c) {
                            return $.extend({}, c, {
                                SubscriptionName: subscriptionsDict[c.SubscriptionId],
                                OkStatus: c.AzureStackCollectiveQuotaStatus.OK,
                                WarningStatus: c.AzureStackCollectiveQuotaStatus.Warning,
                                CriticalStatus: c.AzureStackCollectiveQuotaStatus.Critical,
                            });
                        });
                        _this.quotaStatusGrid.items(transformedQuotas);
                        _this.quotaStatusGrid.loading(false);
                    });
                });
            });
        };
        return UsageAndQuotaStatusGridPartViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.UsageAndQuotaStatusGridPartViewModel = UsageAndQuotaStatusGridPartViewModel;
});
