var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "ClientResources"], function (require, exports, ClientResources) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxControls = MsPortalFx.ViewModels.Controls;
    var AddCloudServiceCustomerProfileBladeViewModel = (function (_super) {
        __extends(AddCloudServiceCustomerProfileBladeViewModel, _super);
        function AddCloudServiceCustomerProfileBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this._selectedSubscriptionId = ko.observable();
            _this.title = ko.observable("Cloud Service Customer Profile");
            _this.icon = ko.observable(MsPortalFx.Base.Images.Person());
            _this._container = container;
            _this._dataContext = dataContext;
            _this._initializeFormFields(container);
            _this.infoBox = new FxControls.InfoBox.ViewModel(container, false);
            _this.subscriptionsDdownField.value.subscribe(container, function (selectedSubscription) {
                if (selectedSubscription != null) {
                    _this._selectedSubscriptionId(selectedSubscription);
                }
            });
            _this._initializeInfoBox();
            _this._setupCommandBar();
            return _this;
        }
        AddCloudServiceCustomerProfileBladeViewModel.prototype._initializeFormFields = function (container) {
            var subscirptionsDdownFieldOptions = {
                label: ko.observable('Subscription'),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.subscriptionsDdownField = new MsPortalFx.ViewModels.Obsolete.Forms.DropDown.ViewModel(container, subscirptionsDdownFieldOptions);
            var firstNameOptions = {
                label: ko.observable("First Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\-]+$/.source, "Invalid"),
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.firstNameTxField = new FxForms.TextBox.ViewModel(container, firstNameOptions);
            var lastNameOptions = {
                label: ko.observable("Last Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\-]+$/.source, "Invalid"),
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.lastNameTxField = new FxForms.TextBox.ViewModel(container, lastNameOptions);
            var cultureOptions = {
                label: ko.observable("Culture"),
            };
            this.cultureTxField = new FxForms.TextBox.ViewModel(container, cultureOptions);
            this.cultureTxField.disabled(true);
            var languageOptions = {
                label: ko.observable("Language"),
            };
            this.languageTxField = new FxForms.TextBox.ViewModel(container, languageOptions);
            this.languageTxField.disabled(true);
            var domainNameOptions = {
                label: ko.observable("Domain Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.domainNameTxField = new FxForms.TextBox.ViewModel(container, domainNameOptions);
            var emailOptions = {
                label: ko.observable("Email Address"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation("^$|^\\b[A-Za-z0-9._%-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,4}\\b", "Invalid"),
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.emailTxField = new FxForms.TextBox.ViewModel(container, emailOptions);
            var phoneOptions = {
                label: ko.observable("Phone Number"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[0-9\+]+[0-9\- ]+$/.source, "Invalid"),
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.phoneNumberTxField = new FxForms.TextBox.ViewModel(container, phoneOptions);
            var companyOptions = {
                label: ko.observable("Company"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[A-Za-z0-9\- ]+$/.source, "Invalid"),
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.companyNameTxField = new FxForms.TextBox.ViewModel(container, companyOptions);
            var addressLine1Options = {
                label: ko.observable("Address Line 1"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\- ]+$/.source, "Invalid"),
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.addressLine1TxField = new FxForms.TextBox.ViewModel(container, addressLine1Options);
            var addressLine2Options = {
                label: ko.observable("Address Line 2")
            };
            this.addressLine2TxField = new FxForms.TextBox.ViewModel(container, addressLine2Options);
            var cityOptions = {
                label: ko.observable("City"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.cityNameTxField = new FxForms.TextBox.ViewModel(container, cityOptions);
            var stateOptions = {
                label: ko.observable("State"),
                infoBalloonContent: ko.observable("State name should be like: WA, CA, NY"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.stateNameTxField = new FxForms.TextBox.ViewModel(container, stateOptions);
            var countryOptions = {
                label: ko.observable("Country"),
            };
            this.countryNameTxField = new FxForms.TextBox.ViewModel(container, countryOptions);
            this.countryNameTxField.disabled(true);
            var postalCodeOptions = {
                label: ko.observable("Postal Code"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[A-Za-z0-9\- ]+$/.source, "Invalid"),
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.postalCodeTxField = new FxForms.TextBox.ViewModel(container, postalCodeOptions);
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.subscriptionsDdownField,
                    this.firstNameTxField,
                    this.lastNameTxField,
                    this.cultureTxField,
                    this.languageTxField,
                    this.domainNameTxField,
                    this.emailTxField,
                    this.phoneNumberTxField,
                    this.companyNameTxField,
                    this.addressLine1TxField,
                    this.addressLine2TxField,
                    this.cityNameTxField,
                    this.stateNameTxField,
                    this.countryNameTxField,
                    this.postalCodeTxField,
                ])
            });
            var options = {
                children: this._formFields
            };
        };
        AddCloudServiceCustomerProfileBladeViewModel.prototype._setupCommandBar = function () {
            var _this = this;
            var saveButton = new MsPortalFx.ViewModels.Toolbars.CommandButton({
                label: ClientResources.Commands.save,
                icon: MsPortalFx.Base.Images.Save(),
                command: {
                    canExecute: ko.observable(true),
                    execute: function (context) {
                        return _this._container.form.triggerValidation().then(function (validationPassed) {
                            if (validationPassed) {
                                return _this._onSaveChanges();
                            }
                            return null;
                        });
                    },
                }
            });
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([saveButton]);
        };
        AddCloudServiceCustomerProfileBladeViewModel.prototype._onSaveChanges = function () {
            var _this = this;
            var customerProfileData = {
                FirstName: this.firstNameTxField.value(),
                LastName: this.lastNameTxField.value(),
                CompanyName: this.companyNameTxField.value(),
                Email: this.emailTxField.value(),
                AddressLine1: this.addressLine1TxField.value(),
                AddressLine2: this.addressLine2TxField.value(),
                City: this.cityNameTxField.value(),
                State: this.stateNameTxField.value(),
                PostalCode: this.postalCodeTxField.value(),
                Country: this.countryNameTxField.value(),
                PhoneNumber: this.phoneNumberTxField.value(),
                Language: this.languageTxField.value(),
                Culture: this.cultureTxField.value(),
                Domain: this.domainNameTxField.value(),
                SubscriptionId: this._selectedSubscriptionId(),
            };
            return this._dataContext.cspDataManager.createCspCustomerProfile(this._selectedSubscriptionId(), customerProfileData)
                .then(function (data) {
                if (data != null) {
                    _this._dataContext.cspDataManager.cspCustomerProfilesQuery.refreshAll();
                    _this._container.closeCurrentBlade();
                }
            });
        };
        AddCloudServiceCustomerProfileBladeViewModel.prototype._initializeInfoBox = function () {
            this.infoBox.size(0);
            this.infoBox.image(MsPortalFx.Base.Images.StatusBadge.Info());
            this.infoBox.text("After your customer profile is created successfully, please refresh the portal.");
            return;
        };
        AddCloudServiceCustomerProfileBladeViewModel.prototype.onInputsSet = function (inputs) {
            var _this = this;
            this.marketDetails = inputs.marketDetails;
            this.cultureTxField.value(this.marketDetails.Culture);
            this.languageTxField.value(this.marketDetails.Language);
            this.countryNameTxField.value(this.marketDetails.Country);
            return this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                var subIds = subscriptions.map(function (s) { return s.subscriptionId; });
                _this._dataContext.cspDataManager.getCspEnabledSubIds(subIds).then(function (subIds) {
                    var dropdownValues = subIds.map(function (s) {
                        return {
                            text: ko.observable(s),
                            value: s,
                            disabled: ko.observable(false)
                        };
                    });
                    dropdownValues.unshift({
                        text: ko.observable("Select a subscription..."),
                        value: "-",
                        disabled: ko.observable(false)
                    });
                    _this.subscriptionsDdownField.options(dropdownValues);
                    var subscriptionId = "-";
                    if (subIds.length > 0)
                        subscriptionId = subIds.first();
                    _this.subscriptionsDdownField.value(subscriptionId);
                    _this.subscriptionsDdownField.disabled(false);
                });
            });
        };
        return AddCloudServiceCustomerProfileBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.AddCloudServiceCustomerProfileBladeViewModel = AddCloudServiceCustomerProfileBladeViewModel;
});
