var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var Dialogs = MsPortalFx.ViewModels.Dialogs;
    var ArmHelpers = Common.Helpers;
    var AssignCloudServiceLicensesBladeViewModel = (function (_super) {
        __extends(AssignCloudServiceLicensesBladeViewModel, _super);
        function AssignCloudServiceLicensesBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this.subscriptionId = ko.observable();
            _this.cspCustomerId = ko.observable();
            _this.cspCustomerUserId = ko.observable();
            _this.location = ko.observable("local");
            _this.availableLicenses = new Array();
            _this.selectedLicenses = ko.observableArray();
            _this.title("Available Cloud Service Licenses");
            _this._container = container;
            _this._dataContext = dataContext;
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 2,
                    activateOnSelected: ko.observable(false)
                }
            };
            _this.availableLicensesGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    itemKey: "Id",
                    name: ko.observable("Offer Id"),
                },
                {
                    itemKey: "Name",
                    name: ko.observable("Name"),
                },
            ];
            _this.availableLicensesGrid.columns = ko.observableArray(basicColumns);
            _this.availableLicensesGrid.showHeader = true;
            _this.availableLicensesGrid.summary = ko.observable("Summary");
            _this.availableLicensesGrid.noRowsMessage("No License available for this user.");
            _this.availableLicensesGrid.selectableData.selectedItems.subscribe(container, function (selectedItems) {
                if (!selectedItems || selectedItems.length === 0) {
                    _this.selectedLicenses([]);
                    return;
                }
                _this.selectedLicenses(selectedItems);
            });
            _this._setupCommandBar();
            return _this;
        }
        AssignCloudServiceLicensesBladeViewModel.prototype._setupCommandBar = function () {
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this._saveButton = this._createSaveButton();
            this.commandBar.setItems([this._saveButton]);
        };
        AssignCloudServiceLicensesBladeViewModel.prototype._createSaveButton = function () {
            var _this = this;
            var saveButton = new FxToolbars.DialogButton({
                label: "Associate",
                icon: MsPortalFx.Base.Images.Link(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure want to associate the selected licenses to the user ?", 4),
                command: {
                    execute: function (result) {
                        if (result === 6) {
                            var licenses_1 = new Array();
                            _this.selectedLicenses().forEach(function (val) {
                                var license = {
                                    SkuId: val.Id,
                                    ExcludedPlans: ""
                                };
                                licenses_1.push(license);
                            });
                            var licenseInfo = {
                                LicensesToAssign: licenses_1
                            };
                            return _this._dataContext.cspDataManager.assignLicensesToCustomerUser(_this.subscriptionId(), _this.cspCustomerId(), _this.cspCustomerUserId(), licenseInfo)
                                .then(function (data) {
                                _this._container.closeCurrentBlade();
                            });
                        }
                    },
                    canExecute: ko.computed(this._container, function () {
                        return _this.selectedLicenses().length != 0;
                    }),
                }
            });
            return saveButton;
        };
        AssignCloudServiceLicensesBladeViewModel.prototype.onInputsSet = function (inputs) {
            this.subscriptionId(inputs.subscriptionId);
            this.cspCustomerId(inputs.cspCustomerId);
            this.cspCustomerUserId(inputs.cspCustomerUserId);
            this.availableLicenses = inputs.availableLicenses;
            if (this.availableLicenses.length == 0)
                this.availableLicensesGrid.items([]);
            this.availableLicensesGrid.items(this.availableLicenses);
            return Q();
        };
        return AssignCloudServiceLicensesBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.AssignCloudServiceLicensesBladeViewModel = AssignCloudServiceLicensesBladeViewModel;
});
