var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ListView = MsPortalFx.ViewModels.Controls.Lists.ListView;
    var CloudServiceOffersListViewModel = (function (_super) {
        __extends(CloudServiceOffersListViewModel, _super);
        function CloudServiceOffersListViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this.title("CSP Offers");
            _this.subtitle("List");
            return _this;
        }
        return CloudServiceOffersListViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.CloudServiceOffersListViewModel = CloudServiceOffersListViewModel;
    var CloudServiceOffersListInstructionsViewModel = (function () {
        function CloudServiceOffersListInstructionsViewModel(container, initialState, dataContext) {
            var _this = this;
            this.loadingImage = ko.observable(MsPortalFx.Base.Images.Loading.Loader());
            this.isOffersLoading = ko.observable(false);
            this.selectedOffer = ko.observable();
            this.subscriptionId = ko.observable();
            this.location = ko.observable("local");
            this.selectedCustomerId = ko.observable();
            this._dataContext = dataContext;
            this.textbox = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, {
                label: ko.observable("Filter By Name or Id"),
                valueUpdateTrigger: 4
            });
            this.cspListViewViewModel = new ListView.ViewModel(container, ListView.Extensions.Selectable | ListView.Extensions.ContextMenu | ListView.Extensions.Filterable, {
                filterable: {
                    filterText: this.textbox.value,
                    filterKey: ko.observable("name")
                },
                selectable: {
                    selectionMode: ListView.SelectionMode.Multiple,
                },
            });
            this.cspListViewViewModel.itemTemplate =
                "<div class='ext-cspOffers-icon' data-bind='image: icon'></div>" +
                    "<div class='ext-cspOffers-container'>" +
                    "<div class='ext-cspOffers-name' data-bind='text: name'></div>" +
                    "<div class='ext-cspOffers-category' data-bind='text: category'></div></br>" +
                    "<div class='ext-cspOffers-description' data-bind='text: description'></div></br>" +
                    "</div>";
            this._view = dataContext.cspDataManager.cspOffersQuery.createView(container);
            this._view.items.subscribe(container, function (value) {
                var itemsMap = value.map(function (value) {
                    var item;
                    var name = value.Name().toString() + "-" + value.Id().toString();
                    var category = value.Category().Name().toString() + "," + value.Billing().toString();
                    var ImageUri = "Content/Images/CspProductLogos/" + value.ThumbnailImageUri();
                    var icon = ko.observable(MsPortalFx.Base.Images.ImageUri(MsPortalFx.Base.Resources.getVersionlessContentUri(ImageUri)));
                    return {
                        id: value.Id(),
                        name: name,
                        icon: icon,
                        category: category,
                        link: value.Links().LearnMore().Uri(),
                        description: value.Description,
                        cssClass: ko.observable("ext-custom-cspOffers"),
                        selectedOffer: ko.observable(value)
                    };
                });
                _this.cspListViewViewModel.items(itemsMap);
                _this.isOffersLoading(false);
            });
        }
        CloudServiceOffersListInstructionsViewModel.prototype.onInputsSet = function () {
            var _this = this;
            return this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                _this.subscriptionId(subscriptions.first().subscriptionId);
                var args = {
                    subscriptionId: _this.subscriptionId(),
                    location: _this.location()
                };
                _this.isOffersLoading(true);
                _this._view.fetch(args);
            });
        };
        return CloudServiceOffersListInstructionsViewModel;
    }());
    exports.CloudServiceOffersListInstructionsViewModel = CloudServiceOffersListInstructionsViewModel;
});
