var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "../../_generated/BladeReferences"], function (require, exports, BladeReferences) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var ArmHelpers = Common.Helpers;
    var CloudServiceUsersBladeViewModel = (function (_super) {
        __extends(CloudServiceUsersBladeViewModel, _super);
        function CloudServiceUsersBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this.subscriptionId = ko.observable();
            _this.cspCustomerId = ko.observable();
            _this.location = ko.observable("local");
            _this.selectedUser = ko.pureComputed(function () {
                return _this.cloudServiceUsersGrid.selectableData.selectedItems().first();
            });
            _this.title("Cloud Users");
            _this._container = container;
            _this._dataContext = dataContext;
            _this._dataQueryView = dataContext.cspDataManager.cspUsersQuery.createView(container, {
                interceptNotFound: false
            });
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1
                }
            };
            _this.cloudServiceUsersGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    itemKey: "Id",
                    name: ko.observable("Microsoft Id"),
                },
                {
                    itemKey: "FirstName",
                    name: ko.observable("First Name"),
                },
                {
                    itemKey: "LastName",
                    name: ko.observable("Last Name"),
                },
                {
                    itemKey: "DisplayName",
                    name: ko.observable("Display Name"),
                },
                {
                    itemKey: "UserPrincipalName",
                    name: ko.observable("User Principal Name"),
                },
            ];
            _this.cloudServiceUsersGrid.columns = ko.observableArray(basicColumns);
            _this.cloudServiceUsersGrid.showHeader = true;
            _this.cloudServiceUsersGrid.summary = ko.observable("Summary");
            _this.cloudServiceUsersGrid.noRowsMessage("No items found");
            _this.cloudServiceUsersGrid.selectableData.selectedItems.subscribe(container, function (selectedItems) {
                if (!selectedItems || selectedItems.length === 0) {
                    return;
                }
            });
            _this._dataQueryView.items.subscribe(container, function (cspUsers) {
                _this.subscriptionId(cspUsers[0].SubscriptionId());
                _this.cspCustomerId(cspUsers[0].CustomerProfileId());
                _this.cloudServiceUsersGrid.items(cspUsers);
            });
            _this._dataQueryView.loading.subscribe(container, function (isLoading) {
                _this.cloudServiceUsersGrid.loading(isLoading);
            });
            _this._setupCommandBar();
            return _this;
        }
        CloudServiceUsersBladeViewModel.prototype._setupCommandBar = function () {
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this._addCspUserButton = this._addCustomerUserButton();
            this._openButton = this._createOpenProfileButton();
            this.commandBar.setItems([this._addCspUserButton, this._openButton]);
        };
        CloudServiceUsersBladeViewModel.prototype._addCustomerUserButton = function () {
            var _this = this;
            var addButton = new FxToolbars.CommandButton({
                label: "Add",
                icon: MsPortalFx.Base.Images.Add(),
                command: {
                    execute: function () {
                        return _this._container.openBlade(new BladeReferences.AddCloudServiceCustomerFormBladeReference({
                            subscriptionId: _this.subscriptionId(),
                            cspCustomerId: _this.cspCustomerId()
                        }));
                    },
                    canExecute: ko.computed(this._container, function () {
                        return true;
                    }),
                }
            });
            return addButton;
        };
        CloudServiceUsersBladeViewModel.prototype._createOpenProfileButton = function () {
            var _this = this;
            var button = new FxToolbars.CommandButton({
                label: "Open",
                icon: MsPortalFx.Base.Images.Expand(),
                command: {
                    execute: function () {
                        return _this._container.openBlade(new BladeReferences.AvailableCloudServiceLicensesBladeReference({
                            subscriptionId: _this.subscriptionId(),
                            cspCustomerId: _this.cspCustomerId(),
                            cspCustomerUserId: _this.selectedUser().Id(),
                        }));
                    },
                    canExecute: ko.computed(this._container, function () {
                        return _this.selectedUser() != null;
                    }),
                }
            });
            return button;
        };
        CloudServiceUsersBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            return this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                var subscriptionId = "-";
                if (subscriptions.length > 0)
                    subscriptionId = subscriptions.first().subscriptionId;
                var args = {
                    subscriptionId: subscriptionId,
                    location: _this.location()
                };
                _this._dataQueryView.fetch(args);
            });
        };
        return CloudServiceUsersBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.CloudServiceUsersBladeViewModel = CloudServiceUsersBladeViewModel;
});
