var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "ClientResources", "../../_generated/ExtensionDefinition", "../../_generated/BladeReferences", "Fx/Composition/Pdl/MenuBlade"], function (require, exports, ClientResources, ExtensionDefinition, BladeReferences, FxMenuBlade) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxImages = MsPortalFx.Base.Images;
    "use strict";
    var CloudServicesMenuBladeViewModel = (function (_super) {
        __extends(CloudServicesMenuBladeViewModel, _super);
        function CloudServicesMenuBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this, container) || this;
            _this.id = ko.observable();
            _this.assetType = ko.observable(ExtensionDefinition.AssetTypeNames.cloudServices);
            _this.assetOwner = ko.observable(ExtensionDefinition.definitionName);
            _this.subscriptionId = ko.observable();
            _this.location = ko.observable("local");
            _this.isCSPIntegrtionEnabledInLicense = ko.observable(false);
            _this.billingMenuGroups = [
                {
                    id: "general",
                    displayText: "Cloud Services",
                    items: [
                        {
                            id: "CspCustomerProfiles",
                            displayText: "Customer Profiles",
                            icon: FxImages.Person(),
                            supplyBladeReference: function () {
                                return new BladeReferences.CloudServiceCustomerProfilesBladeReference();
                            }
                        },
                        {
                            id: "CloudOffers",
                            displayText: "Offers",
                            icon: FxImages.Polychromatic.Website(),
                            supplyBladeReference: function () {
                                return new BladeReferences.CloudServiceOffersListReference();
                            }
                        },
                        {
                            id: "CloudSubscriptions",
                            displayText: "Cloud Subscriptions",
                            icon: FxImages.Polychromatic.Key(),
                            supplyBladeReference: function () {
                                return new BladeReferences.CloudServiceSubscriptionsBladeReference({
                                    cloudServiceUserId: 'dea06bcb-4d9f-4eee-80ea-87e53cad6b2b'
                                });
                            }
                        },
                        {
                            id: "CloudUsers",
                            displayText: "Users",
                            icon: FxImages.Person(),
                            supplyBladeReference: function () {
                                return new BladeReferences.CloudServiceUsersBladeReference();
                            }
                        },
                    ]
                }
            ];
            _this._container = container;
            _this._dataContext = dataContext;
            _this.title(ClientResources.Assets.CloudServices.plural);
            _this.icon(MsPortalFx.Base.Images.Polychromatic.CloudService({ palette: 1 }));
            _this._enabledFeaturesEntityView = _this._dataContext.sharedContext.licenseManager.enabledFeaturesEntity.createView(container, {
                interceptNotFound: false
            });
            return _this;
        }
        CloudServicesMenuBladeViewModel.prototype.onInputsSet = function (inputs) {
            var _this = this;
            return this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                _this.subscriptionId(subscriptions.first().subscriptionId);
                var args = {
                    subscriptionId: _this.subscriptionId(),
                    location: _this.location(),
                };
                var subIds = subscriptions.map(function (s) { return s.subscriptionId; });
                var isCspEnabledInQuota = false;
                _this._enabledFeaturesEntityView.fetch(args).then(function () {
                    var dataEntity = _this._enabledFeaturesEntityView.item();
                    _this._dataContext.cspDataManager.getCspEnabledSubIds(subIds).then(function (subscriptionsIds) {
                        if (subscriptionsIds.length > 0)
                            isCspEnabledInQuota = true;
                        var isCspFeatureEnabled = dataEntity.EnabledFeatures().filter(function (a) { return a.Name() == 'CSPIntegration'; })[0];
                        if (isCspFeatureEnabled && isCspEnabledInQuota)
                            _this.isCSPIntegrtionEnabledInLicense(true);
                        if (_this.isCSPIntegrtionEnabledInLicense()) {
                            _this.menu.groups(_this.billingMenuGroups);
                            _this.menu.groupSortOrder = 0;
                            _this.menu.groupSortFunction = FxMenuBlade.SortFunction.SupportFirst;
                            _this.menu.setOptions({
                                overview: {
                                    id: "Overview",
                                    displayText: "Overview",
                                    icon: FxImages.Polychromatic.CloudService(),
                                    supplyBladeReference: function () {
                                        return new BladeReferences.CloudServicesOverviewBladeReference();
                                    }
                                }
                            });
                        }
                        else {
                            _this._container.unauthorized();
                            _this._container.unauthorizedMessage("Please contact administrator to enable CSP feature.");
                        }
                    });
                });
            });
        };
        return CloudServicesMenuBladeViewModel;
    }(FxMenuBlade.ViewModel));
    exports.CloudServicesMenuBladeViewModel = CloudServicesMenuBladeViewModel;
});
