var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "../../Shared/Helpers"], function (require, exports, Helpers) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var PartViewModels = MsPortalFx.ViewModels.Parts;
    var FxTextProperty = MsPortalFx.ViewModels.Parts.Properties.TextProperty;
    "use strict";
    var CloudServicesOverviewResourceSummaryViewModel = (function (_super) {
        __extends(CloudServicesOverviewResourceSummaryViewModel, _super);
        function CloudServicesOverviewResourceSummaryViewModel(container, initialState, dataContext) {
            var _this = _super.call(this, initialState, CloudServicesOverviewResourceSummaryViewModel._getOptions(container), container) || this;
            _this._cspOverview = ko.observable();
            _this.container = container;
            _this._dataContext = dataContext;
            ko.reactor(container, function () {
                if (_this._cspOverview()) {
                    _this.removeAllProperties();
                    _this._addProperties(_this._cspOverview(), _this.container);
                }
            });
            return _this;
        }
        CloudServicesOverviewResourceSummaryViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            var q3;
            var q1 = _super.prototype.onInputsSet.call(this, inputs, settings);
            var subscriptionIds = this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
            var q2 = this._dataContext.cspDataManager.getCspEnabledSubIds(subscriptionIds).then(function (cspEnabledSubscriptionIds) {
                q3 = _this._dataContext.cspDataManager.getCspOverviewEssentials(cspEnabledSubscriptionIds).then(function (overview) {
                    var overviewObs = Helpers.makeObservable($.extend({}, overview, {}));
                    _this._cspOverview(overviewObs());
                });
            });
            return Q.all([q1, q2, q3]);
        };
        CloudServicesOverviewResourceSummaryViewModel.prototype._addProperties = function (asset, container) {
            if (!asset)
                console.log("Overview Blade: Data is null");
            var isLoading = ko.observable(false);
            var properties = [
                new FxTextProperty({
                    label: "Account Admin",
                    value: asset.AccountAdmin,
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Number of Customer Profiles",
                    value: asset.CspCustomerProfilesCount().toString(),
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Number Of Subscriptions",
                    value: asset.CspSubscriptionsCount().toString(),
                    isLoading: isLoading
                }),
                new FxTextProperty({
                    label: "Number of Customers",
                    value: asset.CspUsersCount().toString(),
                    isLoading: isLoading
                }),
            ];
            this.setProperties(properties);
        };
        CloudServicesOverviewResourceSummaryViewModel._getOptions = function (container) {
            var isLoading = ko.observable(false);
            var properties = [];
            return {
                collapsed: false,
                supportsResourceMove: 4,
                noResourceGroup: true
            };
        };
        return CloudServicesOverviewResourceSummaryViewModel;
    }(PartViewModels.ResourceSummary.ViewModel));
    exports.CloudServicesOverviewResourceSummaryViewModel = CloudServicesOverviewResourceSummaryViewModel;
});
