var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "ClientResources"], function (require, exports, ClientResources) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxForms = MsPortalFx.ViewModels.Forms;
    var OnboardExistingCloudServiceCustomerProfileBladeViewModel = (function (_super) {
        __extends(OnboardExistingCloudServiceCustomerProfileBladeViewModel, _super);
        function OnboardExistingCloudServiceCustomerProfileBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this) || this;
            _this._selectedSubscriptionId = ko.observable();
            _this.title = ko.observable("Customer Profile");
            _this.icon = ko.observable(MsPortalFx.Base.Images.Person());
            _this._container = container;
            _this._dataContext = dataContext;
            _this._initializeFormFields(container);
            _this.subscriptionsDdownField.value.subscribe(container, function (selectedSubscription) {
                if (selectedSubscription != null) {
                    _this._selectedSubscriptionId(selectedSubscription);
                }
            });
            _this._setupCommandBar();
            return _this;
        }
        OnboardExistingCloudServiceCustomerProfileBladeViewModel.prototype._initializeFormFields = function (container) {
            var subscirptionsDdownFieldOptions = {
                label: ko.observable('Subscription'),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.subscriptionsDdownField = new MsPortalFx.ViewModels.Obsolete.Forms.DropDown.ViewModel(container, subscirptionsDdownFieldOptions);
            var existingCustomerIdOptions = {
                label: ko.observable("Microsoft ID"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.existingCustomerIdTxField = new FxForms.TextBox.ViewModel(container, existingCustomerIdOptions);
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.subscriptionsDdownField,
                    this.existingCustomerIdTxField,
                ])
            });
        };
        OnboardExistingCloudServiceCustomerProfileBladeViewModel.prototype._setupCommandBar = function () {
            var _this = this;
            var saveButton = new MsPortalFx.ViewModels.Toolbars.CommandButton({
                label: ClientResources.Commands.save,
                icon: MsPortalFx.Base.Images.Save(),
                command: {
                    canExecute: ko.observable(true),
                    execute: function () {
                        return _this._container.form.triggerValidation().then(function (validationPassed) {
                            if (validationPassed) {
                                return _this._onSaveChanges();
                            }
                            return null;
                        });
                    },
                }
            });
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([saveButton]);
        };
        OnboardExistingCloudServiceCustomerProfileBladeViewModel.prototype._onSaveChanges = function () {
            var _this = this;
            var customerProfileData = {
                ExistingCustomerId: this.existingCustomerIdTxField.value(),
                SubscriptionId: this._selectedSubscriptionId(),
                CustomerId: "",
            };
            return this._dataContext.cspDataManager.onboardExistingCspCustomerProfile(this._selectedSubscriptionId(), customerProfileData)
                .then(function (data) {
                if (data != null) {
                    _this._dataContext.cspDataManager.cspCustomerProfilesQuery.refreshAll();
                    _this._container.closeCurrentBlade();
                }
            });
        };
        OnboardExistingCloudServiceCustomerProfileBladeViewModel.prototype.onInputsSet = function () {
            var _this = this;
            return this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                var subIds = subscriptions.map(function (s) { return s.subscriptionId; });
                _this._dataContext.cspDataManager.getCspEnabledSubIds(subIds).then(function (subIds) {
                    var dropdownValues = subIds.map(function (s) {
                        return {
                            text: ko.observable(s),
                            value: s,
                            disabled: ko.observable(false)
                        };
                    });
                    dropdownValues.unshift({
                        text: ko.observable("Select a subscription..."),
                        value: "-",
                        disabled: ko.observable(false)
                    });
                    _this.subscriptionsDdownField.options(dropdownValues);
                    var subscriptionId = "-";
                    if (subIds.length > 0)
                        subscriptionId = subIds.first();
                    _this.subscriptionsDdownField.value(subscriptionId);
                    _this.subscriptionsDdownField.disabled(false);
                });
            });
        };
        return OnboardExistingCloudServiceCustomerProfileBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.OnboardExistingCloudServiceCustomerProfileBladeViewModel = OnboardExistingCloudServiceCustomerProfileBladeViewModel;
});
