var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FxSubscriptionsDropDown = MsPortalFx.Azure.Subscriptions.DropDown;
    var FxForms = MsPortalFx.ViewModels.Forms;
    var ArmHelpers = Common.Helpers;
    "use strict";
    var resourceProvider = "CloudAssert.Billing";
    var PurchaseCloudServiceBladeViewModel = (function (_super) {
        __extends(PurchaseCloudServiceBladeViewModel, _super);
        function PurchaseCloudServiceBladeViewModel(container, initialState, dataContext) {
            var _this = _super.call(this, container) || this;
            _this.offerId = ko.observable();
            _this.subscriptionId = ko.observable("");
            _this.location = ko.observable("");
            _this._dataLoaded = ko.observable(false);
            _this.editScopeId = ko.observable();
            _this.title = ko.observable("Purchase Cloud Service");
            _this.icon = ko.observable(MsPortalFx.Base.Images.Polychromatic.CloudService());
            _this._container = container;
            _this._dataContext = dataContext;
            _this._galleryItem = ko.observable();
            _this.actionBar = new MsPortalFx.ViewModels.ActionBars.GenericActionBar.ViewModel(container);
            _this.valid.subscribe(container, _this.actionBar.valid);
            _this.parameterProvider = new MsPortalFx.ViewModels.ParameterProvider(container, {
                mapIncomingDataForEditScopeAsync: function (incoming) {
                    var data = {
                        offerName: ko.observable(incoming.offerName),
                        offerId: ko.observable(incoming.offerId),
                        subscription: ko.observable(null),
                        numberOfLicenses: ko.observable(1),
                    };
                    return Q(data);
                },
                mapOutgoingDataForCollector: function (outgoing) { return outgoing; }
            });
            _this.editScope = _this.parameterProvider.editScope;
            _this._initializeFormFields(container, initialState);
            _this.actionBar.actionButtonLabel("Purchase");
            _this.actionBar.actionButtonClick = function () {
                _this.actionBar.disabled(true);
            };
            return _this;
        }
        PurchaseCloudServiceBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            return Q();
        };
        Object.defineProperty(PurchaseCloudServiceBladeViewModel.prototype, "_dataModel", {
            get: function () {
                return this.editScope().root;
            },
            enumerable: true,
            configurable: true
        });
        PurchaseCloudServiceBladeViewModel.prototype._initializeFormFields = function (container, initialState) {
            var _this = this;
            var nameOptions = {
                label: ko.observable("Cloud Service Name"),
                emptyValueText: ko.observable("Cloud Service Name"),
                readonly: true
            };
            this.nameTxField = new FxForms.TextBox.ViewModel(container, this, this.createEditScopeAccessor(function (data) { return data.offerName; }), nameOptions);
            var licensesOptions = {
                label: ko.observable("Number of licenses"),
                emptyValueText: ko.observable("")
            };
            this.numerOfLicensesTxField = new FxForms.NumericTextBox.ViewModel(container, this, this.createEditScopeAccessor(function (data) { return data.numberOfLicenses; }), licensesOptions);
            var subscriptionsDropDownOptions = {
                options: ko.observableArray([]),
                form: this,
                accessor: this.createEditScopeAccessor(function (data) {
                    return data.subscription;
                }),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Please select a Subscription")
                ]),
                resourceProviders: ko.observable([resourceProvider]),
                filterByGalleryItem: this._galleryItem
            };
            this.subscriptionsDropDown = new FxSubscriptionsDropDown(container, subscriptionsDropDownOptions);
            this.subscriptionsDropDown.subscriptionId.subscribe(container, function (newSubscriptionId) {
                _this.subscriptionId(newSubscriptionId);
            });
            var sectionOptions = {
                children: ko.observableArray([
                    this.nameTxField,
                    this.subscriptionsDropDown.control,
                    this.numerOfLicensesTxField
                ])
            };
            this.generalSection = new FxForms.Section.ViewModel(container, sectionOptions);
            this.sections.push(this.generalSection);
        };
        return PurchaseCloudServiceBladeViewModel;
    }(FxForms.Form.ViewModel));
    exports.PurchaseCloudServiceBladeViewModel = PurchaseCloudServiceBladeViewModel;
});
