var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "./_generated/ExtensionDefinition", "./_generated/ViewModelFactories", "./Shared/SharedArea", "./Billing/BillingArea", "./CloudServices/CloudServicesArea"], function (require, exports, ExtensionDefinition, ViewModelFactories, SharedArea, BillingArea, CloudServicesArea) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ArmHelpers = Common.Helpers;
    "use strict";
    var EntryPoint = (function (_super) {
        __extends(EntryPoint, _super);
        function EntryPoint() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        EntryPoint.prototype.initialize = function () {
            this.viewModelFactories = new ViewModelFactories.ViewModelFactoriesBase();
            ArmHelpers.apiVersion = window.fx.environment.armApiVersion;
            this._initializeDataContexts();
        };
        EntryPoint.prototype.getDefinition = function () {
            return ExtensionDefinition.getDefinition();
        };
        EntryPoint.prototype._initializeDataContexts = function () {
            var sharedContext = new SharedArea.DataContext();
            var billingDataContext = new BillingArea.DataContext(sharedContext);
            var cloudServicesDataContext = new CloudServicesArea.DataContext(sharedContext);
            this.viewModelFactories.Billing().setDataContext(billingDataContext);
            this.viewModelFactories.CloudServices().setDataContext(cloudServicesDataContext);
        };
        return EntryPoint;
    }(MsPortalFx.Extension.EntryPointBase));
    function create() {
        return new EntryPoint();
    }
    exports.create = create;
});
