define(["require", "exports", "../Blades/TenantBillingStyles.css", "../Blades/DocStyles.css", "ClientResources", "../../Billing/ViewModels/Overview/BillingOverviewBladeViewModel", "../../Billing/ViewModels/UserBillingHistoryChartPartViewModel", "../../Billing/ViewModels/Overview/BillingOverviewResourceSummaryViewModel"], function (require, exports, BladesTenantBillingStylescss, BladesDocStylescss, ClientResources) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.blade = {
        "name": "BillingOverviewBlade",
        "inputs": [
            "id"
        ],
        "templateKeyInputs": [
            "id"
        ],
        "viewModelName": "Billing$BillingOverviewBladeViewModel",
        "lenses": [
            {
                "title": ClientResources.subscriptionsYouOwn,
                "name": "BillingHistoryChartBladeLens",
                "partInstances": [
                    {
                        "name": "OwnedSubscriptionsOverviewGridPart",
                        "reference": {
                            "partTypeName": "SubscriptionsOverviewGridPart",
                            "bindings": [
                                {
                                    "property": "subscriptionsCategory",
                                    "valuesFrom": [
                                        {
                                            "referenceType": 5,
                                            "property": "constant_Owned",
                                            "constantValue": "Owned"
                                        }
                                    ]
                                },
                                {
                                    "property": "monitorBillingPeriodDropDown",
                                    "valuesFrom": [
                                        {
                                            "referenceType": 5,
                                            "property": "constant_false",
                                            "constantValue": "false"
                                        }
                                    ]
                                }
                            ],
                            "initialSize": 5
                        }
                    },
                    {
                        "name": "UserBillingHistoryChartInstructions",
                        "inline": {
                            "viewModel": "Billing$UserBillingHistoryChartPartViewModel",
                            "partKind": 0,
                            "inputs": [],
                            "bindings": [],
                            "details": [],
                            "initialSize": 5,
                            "supportedSizes": [
                                5
                            ],
                            "htmlTemplateInline": {
                                "file": "UserBillingHistoryChartPart.html",
                                "content": "<div data-bind=\"pcControl: barChartVM\" style=\"height: 300px\"></div> "
                            },
                            "styleSheets": [
                                {
                                    "file": "Blades/TenantBillingStyles.css",
                                    "content": BladesTenantBillingStylescss
                                },
                                {
                                    "file": "Blades/DocStyles.css",
                                    "content": BladesDocStylescss
                                }
                            ]
                        }
                    }
                ]
            },
            {
                "title": ClientResources.otherSubscriptionsYouAreAssociatedWith,
                "name": "OtherSubscriptionsBladeLens",
                "partInstances": [
                    {
                        "name": "AssociatedSubscriptionsOverviewGridPart",
                        "reference": {
                            "partTypeName": "SubscriptionsOverviewGridPart",
                            "bindings": [
                                {
                                    "property": "subscriptionsCategory",
                                    "valuesFrom": [
                                        {
                                            "referenceType": 5,
                                            "property": "constant_Associated",
                                            "constantValue": "Associated"
                                        }
                                    ]
                                },
                                {
                                    "property": "monitorBillingPeriodDropDown",
                                    "valuesFrom": [
                                        {
                                            "referenceType": 5,
                                            "property": "constant_false",
                                            "constantValue": "false"
                                        }
                                    ]
                                }
                            ],
                            "initialSize": 5
                        }
                    }
                ]
            },
            {
                "isSummary": true,
                "name": "BillingOverviewResourceSummary",
                "partInstances": [
                    {
                        "name": "ResourceSummaryPart",
                        "inline": {
                            "viewModel": "Billing$BillingOverviewResourceSummaryViewModel",
                            "partKind": 30,
                            "inputs": [
                                "resourceId"
                            ],
                            "bindings": [
                                {
                                    "property": "resourceId",
                                    "valuesFrom": [
                                        {
                                            "referenceType": 3,
                                            "property": "content.id"
                                        }
                                    ]
                                }
                            ],
                            "details": [
                                {
                                    "invocationInputArguments": [
                                        {
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 0,
                                                    "property": "content.selection"
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    "invocationInputArguments": [
                                        {
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 0,
                                                    "property": "content.asyncSelection"
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    "invocationInputArguments": [
                                        {
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 0,
                                                    "property": "content.tagsSelectable"
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    "invocationInputArguments": [
                                        {
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 0,
                                                    "property": "content.accessSelectable"
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    "invocationInputArguments": [
                                        {
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 0,
                                                    "property": "content.settingsSelectable"
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    "invocationInputArguments": [
                                        {
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 0,
                                                    "property": "content.quickStartSelectable"
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    "invocationInputArguments": [
                                        {
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 0,
                                                    "property": "content.keysSelectable"
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    "invocationInputArguments": [
                                        {
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 0,
                                                    "property": "content.moveResourceSelection"
                                                }
                                            ]
                                        }
                                    ],
                                    "outputArguments": [
                                        {
                                            "property": "actionBarOutput",
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 1,
                                                    "property": "actionBarOutput"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ],
                            "initialSize": 4,
                            "partState": {
                                "inputIdentityProperties": [
                                    "content.collapsed"
                                ]
                            },
                            "styleSheets": []
                        }
                    }
                ]
            }
        ],
        "viewModelInputs": [
            {
                "property": "id",
                "valuesFrom": [
                    {
                        "referenceType": 1,
                        "property": "id"
                    }
                ]
            }
        ],
        "width": 3,
        "locked": false,
        "attributes": 0
    };
});
