define(["require", "exports", "../Blades/TenantBillingStyles.css", "../Blades/DocStyles.css", "../../Billing/ViewModels/Overview/BillingOverviewSettingsListBladeViewModel", "../../Billing/ViewModels/Overview/BillingOverviewSettingsListPartViewModel"], function (require, exports, BladesTenantBillingStylescss, BladesDocStylescss) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.blade = {
        "name": "BillingOverviewSettingsListBlade",
        "inputs": [
            "id"
        ],
        "viewModelName": "Billing$BillingOverviewSettingsListBladeViewModel",
        "lenses": [
            {
                "name": "SettingListLens",
                "partInstances": [
                    {
                        "name": "SettingListPart",
                        "inline": {
                            "viewModel": "Billing$BillingOverviewSettingsListPartViewModel",
                            "partKind": 0,
                            "inputs": [
                                "id"
                            ],
                            "bindings": [
                                {
                                    "property": "id",
                                    "valuesFrom": [
                                        {
                                            "referenceType": 1,
                                            "property": "id"
                                        }
                                    ]
                                }
                            ],
                            "details": [
                                {
                                    "invocationInputArguments": [
                                        {
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 0,
                                                    "property": "content.settingList.selectableData"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ],
                            "initialSize": 8,
                            "supportedSizes": [
                                8
                            ],
                            "viewStateProperties": [
                                "content.settingList.selectableData.activatedItems",
                                "content.settingList.selectableData.selectedItems"
                            ],
                            "htmlTemplateInline": {
                                "file": "Client\\Billing\\Billing.UserOverview.pdl",
                                "content": "<div data-bind=\"pcGrid: settingList\"></div>"
                            },
                            "styleSheets": [
                                {
                                    "file": "Blades/TenantBillingStyles.css",
                                    "content": BladesTenantBillingStylescss
                                },
                                {
                                    "file": "Blades/DocStyles.css",
                                    "content": BladesDocStylescss
                                }
                            ]
                        }
                    }
                ]
            }
        ],
        "viewModelInputs": [
            {
                "property": "id",
                "valuesFrom": [
                    {
                        "referenceType": 1,
                        "property": "id"
                    }
                ]
            }
        ],
        "width": 0,
        "locked": true,
        "style": 11,
        "attributes": 0
    };
});
