define(["require", "exports", "../Blades/TenantBillingStyles.css", "../Blades/DocStyles.css", "../Blades/CustomStyles.css", "../../CloudServices/ViewModels/CloudServiceOffersListViewModel"], function (require, exports, BladesTenantBillingStylescss, BladesDocStylescss, BladesCustomStylescss) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.blade = {
        "name": "CloudServiceOffersList",
        "viewModelName": "CloudServices$CloudServiceOffersListViewModel",
        "lenses": [
            {
                "name": "CustomListViewInstructionsLens",
                "partInstances": [
                    {
                        "name": "CloudServiceOffersListInstructions",
                        "inline": {
                            "viewModel": "CloudServices$CloudServiceOffersListInstructionsViewModel",
                            "partKind": 0,
                            "inputs": [],
                            "bindings": [],
                            "details": [
                                {
                                    "selectablePath": "content.cspListViewViewModel.extensionOptions.selectable.selection",
                                    "blade": "CloudServiceOffersListViewChildBlade",
                                    "selectableBindings": [
                                        {
                                            "property": "id",
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 6,
                                                    "property": "id"
                                                }
                                            ]
                                        },
                                        {
                                            "property": "selectedOffer",
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 6,
                                                    "property": "selectedOffer"
                                                }
                                            ]
                                        }
                                    ],
                                    "additionalInputArguments": [
                                        {
                                            "property": "subscriptionId",
                                            "valuesFrom": [
                                                {
                                                    "referenceType": 0,
                                                    "property": "content.subscriptionId"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ],
                            "initialSize": 8,
                            "supportedSizes": [
                                8
                            ],
                            "htmlTemplateInline": {
                                "file": "CloudServiceOffersListInstructionsViewModel.html",
                                "content": "<b><span style=\"margin-top: 50px; text-transform:uppercase; font-size: 15px;\">Microsoft Offers</span></b> <br/> <br/> <div data-bind='pcControl: textbox'></div> <div data-bind=\"image: loadingImage, visible: isOffersLoading\" style=\"width:50px;margin-left:45%; padding-top: 5%\" alt=\"loading\"></div> <div data-bind='pcControl: cspListViewViewModel'></div> "
                            },
                            "styleSheets": [
                                {
                                    "file": "Blades/TenantBillingStyles.css",
                                    "content": BladesTenantBillingStylescss
                                },
                                {
                                    "file": "Blades/DocStyles.css",
                                    "content": BladesDocStylescss
                                },
                                {
                                    "file": "Blades/CustomStyles.css",
                                    "content": BladesCustomStylescss
                                }
                            ]
                        }
                    }
                ]
            }
        ],
        "width": 2,
        "attributes": 0
    };
});
