define(["require", "exports", "ClientResources"], function (require, exports, ClientResources) {
    "use strict";
    var ExtensionDefinition;
    (function (ExtensionDefinition) {
        var Internal;
        (function (Internal) {
            var untypedDefinition = {
                "commandsCatalog": [],
                "name": "CloudAssertBillingTenantExtension",
                "version": "1.0",
                "hash": "47DEQpj8HBSa+/TImW+5JCeuQeRkm5NMpJWZG3hSuFU=",
                "schemaVersion": "1.0.0.2",
                "sdkVersion": "5.0.302.1701 (production_sdk#025f5c0c48.180820-2119) Signed",
                "commandGroups": [
                    {
                        "name": "SubscriptionGridCommands",
                        "commands": [
                            {
                                "name": "DownloadSubscriptionUsageCommand",
                                "text": ClientResources.Commands.downloadUsage,
                                "viewModel": "Billing$DownloadUsageCommandViewModel",
                                "commandKind": 3,
                                "bindings": [
                                    {
                                        "property": "subscriptionId",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 1,
                                                "property": "SubscriptionId"
                                            }
                                        ]
                                    },
                                    {
                                        "property": "billingPeriod",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 1,
                                                "property": "BillingPeriod"
                                            }
                                        ]
                                    }
                                ]
                            }
                        ]
                    }
                ],
                "htmlTemplates": {}
            };
            Internal.definition = untypedDefinition;
        })(Internal || (Internal = {}));
        ExtensionDefinition.definitionName = "CloudAssertBillingTenantExtension";
        function getDefinition() {
            if (Internal.definition) {
                var def = Internal.definition;
                Internal.definition = null;
                return def;
            }
            throw new Error("Extension definition is no longer available.");
        }
        ExtensionDefinition.getDefinition = getDefinition;
        var External;
        (function (External) {
            var HubsExtension;
            (function (HubsExtension) {
                HubsExtension.name = "HubsExtension";
                var Blades;
                (function (Blades) {
                    var ResourceGroupMapBlade;
                    (function (ResourceGroupMapBlade) {
                        ResourceGroupMapBlade.name = "ResourceGroupMapBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.id = "id";
                        })(Inputs = ResourceGroupMapBlade.Inputs || (ResourceGroupMapBlade.Inputs = {}));
                    })(ResourceGroupMapBlade = Blades.ResourceGroupMapBlade || (Blades.ResourceGroupMapBlade = {}));
                    var AssignTagsBlade;
                    (function (AssignTagsBlade) {
                        AssignTagsBlade.name = "AssignTagsBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.resources = "resources";
                        })(Inputs = AssignTagsBlade.Inputs || (AssignTagsBlade.Inputs = {}));
                    })(AssignTagsBlade = Blades.AssignTagsBlade || (Blades.AssignTagsBlade = {}));
                    var EditTagsBlade;
                    (function (EditTagsBlade) {
                        EditTagsBlade.name = "EditTagsBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.resource = "resource";
                        })(Inputs = EditTagsBlade.Inputs || (EditTagsBlade.Inputs = {}));
                    })(EditTagsBlade = Blades.EditTagsBlade || (Blades.EditTagsBlade = {}));
                    var UnauthorizedAssetBlade;
                    (function (UnauthorizedAssetBlade) {
                        UnauthorizedAssetBlade.name = "UnauthorizedAssetBlade";
                    })(UnauthorizedAssetBlade = Blades.UnauthorizedAssetBlade || (Blades.UnauthorizedAssetBlade = {}));
                    var NotFoundAssetBlade;
                    (function (NotFoundAssetBlade) {
                        NotFoundAssetBlade.name = "NotFoundAssetBlade";
                    })(NotFoundAssetBlade = Blades.NotFoundAssetBlade || (Blades.NotFoundAssetBlade = {}));
                    var UnavailableAssetBlade;
                    (function (UnavailableAssetBlade) {
                        UnavailableAssetBlade.name = "UnavailableAssetBlade";
                    })(UnavailableAssetBlade = Blades.UnavailableAssetBlade || (Blades.UnavailableAssetBlade = {}));
                    var Resources;
                    (function (Resources) {
                        Resources.name = "Resources";
                    })(Resources = Blades.Resources || (Blades.Resources = {}));
                    var BrowseAllResourcesBlade;
                    (function (BrowseAllResourcesBlade) {
                        BrowseAllResourcesBlade.name = "BrowseAllResourcesBlade";
                    })(BrowseAllResourcesBlade = Blades.BrowseAllResourcesBlade || (Blades.BrowseAllResourcesBlade = {}));
                    var BrowseAllInMenu;
                    (function (BrowseAllInMenu) {
                        BrowseAllInMenu.name = "BrowseAllInMenu";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.resourceType = "resourceType";
                        })(Inputs = BrowseAllInMenu.Inputs || (BrowseAllInMenu.Inputs = {}));
                    })(BrowseAllInMenu = Blades.BrowseAllInMenu || (Blades.BrowseAllInMenu = {}));
                    var BrowseResourceBlade;
                    (function (BrowseResourceBlade) {
                        BrowseResourceBlade.name = "BrowseResourceBlade";
                    })(BrowseResourceBlade = Blades.BrowseResourceBlade || (Blades.BrowseResourceBlade = {}));
                    var BrowseInMenu;
                    (function (BrowseInMenu) {
                        BrowseInMenu.name = "BrowseInMenu";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.resourceType = "resourceType";
                        })(Inputs = BrowseInMenu.Inputs || (BrowseInMenu.Inputs = {}));
                    })(BrowseInMenu = Blades.BrowseInMenu || (Blades.BrowseInMenu = {}));
                    var BrowseInstanceLinkBlade;
                    (function (BrowseInstanceLinkBlade) {
                        BrowseInstanceLinkBlade.name = "BrowseInstanceLinkBlade";
                    })(BrowseInstanceLinkBlade = Blades.BrowseInstanceLinkBlade || (Blades.BrowseInstanceLinkBlade = {}));
                    var BrowseResourceGroupBlade;
                    (function (BrowseResourceGroupBlade) {
                        BrowseResourceGroupBlade.name = "BrowseResourceGroupBlade";
                    })(BrowseResourceGroupBlade = Blades.BrowseResourceGroupBlade || (Blades.BrowseResourceGroupBlade = {}));
                    var BrowseGroupsInMenu;
                    (function (BrowseGroupsInMenu) {
                        BrowseGroupsInMenu.name = "BrowseGroupsInMenu";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.resourceType = "resourceType";
                        })(Inputs = BrowseGroupsInMenu.Inputs || (BrowseGroupsInMenu.Inputs = {}));
                    })(BrowseGroupsInMenu = Blades.BrowseGroupsInMenu || (Blades.BrowseGroupsInMenu = {}));
                    var MapResourceGroupBlade;
                    (function (MapResourceGroupBlade) {
                        MapResourceGroupBlade.name = "MapResourceGroupBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.id = "id";
                        })(Inputs = MapResourceGroupBlade.Inputs || (MapResourceGroupBlade.Inputs = {}));
                    })(MapResourceGroupBlade = Blades.MapResourceGroupBlade || (Blades.MapResourceGroupBlade = {}));
                    var ResourceProperties;
                    (function (ResourceProperties) {
                        ResourceProperties.name = "ResourceProperties";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.id = "id";
                        })(Inputs = ResourceProperties.Inputs || (ResourceProperties.Inputs = {}));
                    })(ResourceProperties = Blades.ResourceProperties || (Blades.ResourceProperties = {}));
                    var ResourceGroupPickerV3Blade;
                    (function (ResourceGroupPickerV3Blade) {
                        ResourceGroupPickerV3Blade.name = "ResourceGroupPickerV3Blade";
                    })(ResourceGroupPickerV3Blade = Blades.ResourceGroupPickerV3Blade || (Blades.ResourceGroupPickerV3Blade = {}));
                    var DeployToAzure;
                    (function (DeployToAzure) {
                        DeployToAzure.name = "DeployToAzure";
                    })(DeployToAzure = Blades.DeployToAzure || (Blades.DeployToAzure = {}));
                    var DeployFromTemplateBlade;
                    (function (DeployFromTemplateBlade) {
                        DeployFromTemplateBlade.name = "DeployFromTemplateBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.internal_bladeCallerParams = "internal_bladeCallerParams";
                        })(Inputs = DeployFromTemplateBlade.Inputs || (DeployFromTemplateBlade.Inputs = {}));
                    })(DeployFromTemplateBlade = Blades.DeployFromTemplateBlade || (Blades.DeployFromTemplateBlade = {}));
                    var ParametersEditorBlade;
                    (function (ParametersEditorBlade) {
                        ParametersEditorBlade.name = "ParametersEditorBlade";
                    })(ParametersEditorBlade = Blades.ParametersEditorBlade || (Blades.ParametersEditorBlade = {}));
                    var ParametersFileEditorBlade;
                    (function (ParametersFileEditorBlade) {
                        ParametersFileEditorBlade.name = "ParametersFileEditorBlade";
                    })(ParametersFileEditorBlade = Blades.ParametersFileEditorBlade || (Blades.ParametersFileEditorBlade = {}));
                    var TemplateEditorBlade;
                    (function (TemplateEditorBlade) {
                        TemplateEditorBlade.name = "TemplateEditorBlade";
                    })(TemplateEditorBlade = Blades.TemplateEditorBlade || (Blades.TemplateEditorBlade = {}));
                    var LocationPickerV3Blade;
                    (function (LocationPickerV3Blade) {
                        LocationPickerV3Blade.name = "LocationPickerV3Blade";
                    })(LocationPickerV3Blade = Blades.LocationPickerV3Blade || (Blades.LocationPickerV3Blade = {}));
                    var DeploymentInputsBlade;
                    (function (DeploymentInputsBlade) {
                        DeploymentInputsBlade.name = "DeploymentInputsBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.id = "id";
                        })(Inputs = DeploymentInputsBlade.Inputs || (DeploymentInputsBlade.Inputs = {}));
                    })(DeploymentInputsBlade = Blades.DeploymentInputsBlade || (Blades.DeploymentInputsBlade = {}));
                    var DeploymentOutputsBlade;
                    (function (DeploymentOutputsBlade) {
                        DeploymentOutputsBlade.name = "DeploymentOutputsBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.id = "id";
                        })(Inputs = DeploymentOutputsBlade.Inputs || (DeploymentOutputsBlade.Inputs = {}));
                    })(DeploymentOutputsBlade = Blades.DeploymentOutputsBlade || (Blades.DeploymentOutputsBlade = {}));
                    var ResourceMenuBlade;
                    (function (ResourceMenuBlade) {
                        ResourceMenuBlade.name = "ResourceMenuBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.id = "id";
                        })(Inputs = ResourceMenuBlade.Inputs || (ResourceMenuBlade.Inputs = {}));
                    })(ResourceMenuBlade = Blades.ResourceMenuBlade || (Blades.ResourceMenuBlade = {}));
                    var ServicesHealthBlade;
                    (function (ServicesHealthBlade) {
                        ServicesHealthBlade.name = "ServicesHealthBlade";
                    })(ServicesHealthBlade = Blades.ServicesHealthBlade || (Blades.ServicesHealthBlade = {}));
                    var SubscriptionPickerV3Blade;
                    (function (SubscriptionPickerV3Blade) {
                        SubscriptionPickerV3Blade.name = "SubscriptionPickerV3Blade";
                    })(SubscriptionPickerV3Blade = Blades.SubscriptionPickerV3Blade || (Blades.SubscriptionPickerV3Blade = {}));
                })(Blades = HubsExtension.Blades || (HubsExtension.Blades = {}));
            })(HubsExtension = External.HubsExtension || (External.HubsExtension = {}));
        })(External = ExtensionDefinition.External || (ExtensionDefinition.External = {}));
        var AssetTypes;
        (function (AssetTypes) {
            var Billing;
            (function (Billing) {
                Billing.name = "Billing";
            })(Billing = AssetTypes.Billing || (AssetTypes.Billing = {}));
            var CloudServices;
            (function (CloudServices) {
                CloudServices.name = "CloudServices";
            })(CloudServices = AssetTypes.CloudServices || (AssetTypes.CloudServices = {}));
        })(AssetTypes = ExtensionDefinition.AssetTypes || (ExtensionDefinition.AssetTypes = {}));
        var AssetTypeNames;
        (function (AssetTypeNames) {
            AssetTypeNames.billing = AssetTypes.Billing.name;
            AssetTypeNames.cloudServices = AssetTypes.CloudServices.name;
        })(AssetTypeNames = ExtensionDefinition.AssetTypeNames || (ExtensionDefinition.AssetTypeNames = {}));
        var BladeNames;
        (function (BladeNames) {
            BladeNames.billingMenuBlade = "BillingMenuBlade";
            BladeNames.invoicesCollectionBlade = "InvoicesCollectionBlade";
            BladeNames.invoiceDetailBlade = "InvoiceDetailBlade";
            BladeNames.paymentMethodsBlade = "PaymentMethodsBlade";
            BladeNames.subscriptionOverviewBlade = "SubscriptionOverviewBlade";
            BladeNames.usageHistoryByResourcesGridBlade = "UsageHistoryByResourcesGridBlade";
            BladeNames.usageHistoryBlade = "UsageHistoryBlade";
            BladeNames.billingOverviewBlade = "BillingOverviewBlade";
            BladeNames.billingOverviewSettingsListBlade = "BillingOverviewSettingsListBlade";
            BladeNames.billingOverviewPropertiesBlade = "BillingOverviewPropertiesBlade";
            BladeNames.userBasicProfileBlade = "UserBasicProfileBlade";
            BladeNames.contactInfoBlade = "ContactInfoBlade";
            BladeNames.billingAddressBlade = "BillingAddressBlade";
            BladeNames.notificationMessagesBlade = "NotificationMessagesBlade";
            BladeNames.notificationRulesBlade = "NotificationRulesBlade";
            BladeNames.notificationAddEditBlade = "NotificationAddEditBlade";
            BladeNames.notificationMessageDetailsBlade = "NotificationMessageDetailsBlade";
            BladeNames.usageAndQuotaStatusBlade = "UsageAndQuotaStatusBlade";
            BladeNames.usageAndQuotaSnapInBlade = "UsageAndQuotaSnapInBlade";
            BladeNames.usageAndQuotaTrendBlade = "UsageAndQuotaTrendBlade";
            BladeNames.cloudServicesMenuBlade = "CloudServicesMenuBlade";
            BladeNames.cloudServiceCustomerProfilesBlade = "CloudServiceCustomerProfilesBlade";
            BladeNames.addCloudServiceCustomerProfileBlade = "AddCloudServiceCustomerProfileBlade";
            BladeNames.onboardExistingCloudServiceCustomerProfileBlade = "OnboardExistingCloudServiceCustomerProfileBlade";
            BladeNames.cloudServiceUsersBlade = "CloudServiceUsersBlade";
            BladeNames.addCloudServiceCustomerFormBlade = "AddCloudServiceCustomerFormBlade";
            BladeNames.availableCloudServiceLicensesBlade = "AvailableCloudServiceLicensesBlade";
            BladeNames.assignCloudServiceLicensesBlade = "AssignCloudServiceLicensesBlade";
            BladeNames.cloudServiceOffersList = "CloudServiceOffersList";
            BladeNames.cloudServiceOffersListViewChildBlade = "CloudServiceOffersListViewChildBlade";
            BladeNames.cloudServicesOverviewBlade = "CloudServicesOverviewBlade";
            BladeNames.purchaseCloudServiceBlade = "PurchaseCloudServiceBlade";
            BladeNames.cloudServiceSubscriptionDetailsBlade = "CloudServiceSubscriptionDetailsBlade";
            BladeNames.cloudServiceSubscriptionsBlade = "CloudServiceSubscriptionsBlade";
        })(BladeNames = ExtensionDefinition.BladeNames || (ExtensionDefinition.BladeNames = {}));
        var CommandGroupNames;
        (function (CommandGroupNames) {
            CommandGroupNames.subscriptionGridCommands = "SubscriptionGridCommands";
        })(CommandGroupNames = ExtensionDefinition.CommandGroupNames || (ExtensionDefinition.CommandGroupNames = {}));
    })(ExtensionDefinition || (ExtensionDefinition = {}));
    return ExtensionDefinition;
});
